// Main.cpp

#include "stdafx.h"

#include "Tablet.h"
using namespace Tablet;
ITablet* theTablet;

#include "mew/MessageMap.h"
#include "mew/FileTreeCtrl.h"
#include "mew/FileListCtrl.h"
using namespace mew;

#include "resource.h"

const UINT MENU_SHELL_FIRST	= 0x0001;
const UINT MENU_SHELL_LAST	= 0x3FFF;
const UINT MENU_FILE_FIRST	= 0x4000;
const UINT MENU_FILE_LAST	= 0x7FFF;
const UINT MENU_FILER		= 0x8000;

const INT ID_FILER_SYNC	= 0x8000;
const INT ID_FILER_OPEN	= 0x8001;
const INT ID_FILER_ADD	= 0x8002;

namespace Filer
{
	void InsertPrivateMenu(CMenuHandle popup)
	{
		popup.InsertMenu(0, MF_BYPOSITION, ID_FILER_OPEN, _T("V^uŊJ"));
		popup.InsertMenu(1, MF_BYPOSITION, ID_FILER_ADD , _T("ǉ̃^uŊJ"));
		popup.InsertMenu(2, MF_BYPOSITION | MF_SEPARATOR);
		popup.SetMenuDefaultItem(0, TRUE);
	}

	// ReLXgj[\ɃXe[^Xo[ɓe\邽߂̃Tu[`B
	HRESULT OnGetMenuItemName(DWORD wID, HMENU hMenu, LPTSTR name, INT cch)
	{
		if(hMenu)
			return E_FAIL;
		switch(wID)
		{
		case ID_FILER_SYNC:
			lstrcpy(name, _T("tH_c[ƃr[𓯊"));
			return S_OK;
		case ID_FILER_OPEN:
			lstrcpy(name, _T("I𒆂̍ڂ V^uŊJ"));
			return S_OK;
		case ID_FILER_ADD:
			lstrcpy(name, _T("I𒆂̍ڂ ǉ̃^uŊJ"));
			return S_OK;
		default:
			return E_FAIL;
		}
	}

	WindowID CommandToWindow(UINT cmd)
	{
		switch(cmd)
		{
		case ID_FILER_OPEN:
			return WINDOW_PANE_ACTIVE;
		case ID_FILER_ADD:
			return (WindowID)min(WINDOW_PANE_LAST, WINDOW_PANE_FIRST + theTablet->CountElements(WINDOW_PANESPLITTER));
		default:
			return WINDOW_PANE_ACTIVE;
		}
	}
}

#include "View.h"
#include "SideBar.h"

const LPCTSTR NEW_NAME[] =
{
	_T("tH_ [Filer]"),
};

//#define ENBALE_FOLDER_DIALOG

#ifdef ENBALE_FOLDER_DIALOG

// t@Ĉق ITEMIDLIST ~߁B
class CFolderDialogEx : public CFolderDialog
{
public:
	CAutoPtr<CShellItemTask> m_pShellItem;

	CFolderDialogEx(HWND hWnd) : CFolderDialog(hWnd, _T("tH_J"), BIF_RETURNONLYFSDIRS | BIF_USENEWUI | BIF_VALIDATE)
	{
	}
	INT_PTR DoModal(HWND hWndParent = ::GetActiveWindow())
	{
		if(m_bi.hwndOwner == NULL)	// set only if not specified before
			m_bi.hwndOwner = hWndParent;

		INT_PTR nRet = -1;
		m_pShellItem.Attach((CShellItemTask*)::SHBrowseForFolder(&m_bi));
		if(m_pShellItem)
		{
			::SHGetPathFromIDList(m_pShellItem, m_szFolderPath);
			nRet = IDOK;
		}

		return nRet;
	}
};

#endif

class CFactory : public CFactoryImpl<CFactory>
{
public:
	void OnFinalMessage(HWND)
	{
		delete this;
	}

	////////////////////////////////////////////////////////////////////////////////
	// CFactoryCommands

	BOOL DoNew(UINT what, WindowID parent)
	{
#ifdef ENBALE_FOLDER_DIALOG
		CFolderDialogEx dlg(theTablet->GetWindow(WINDOW_MAINFRAME));
		if(dlg.DoModal() != IDOK)
			return FALSE;
		return CView::New(dlg.m_pShellItem, NULL, parent) != NULL;
#else
		return CView::New(CShellItemTask::FromCSIDL(CSIDL_PERSONAL, theTablet->GetWindow(WINDOW_MAINFRAME)), NULL, parent) != NULL;
#endif
	}
	INT  DoQuerySuitable(const FileNode* node)
	{
		if(!node->IsFile() && node->pidl)
			return SUIT_MIDDLE;
		else
			return SUIT_NONE;
	}
	BOOL DoOpen(const FileNode* node, WindowID parent)
	{
		if(!node->pidl)
			return FALSE;
		CAutoPtr<CShellItemTask> item = CShellItemTask::Duplicate(node->pidl);
		return CView::New(item, NULL, parent) != NULL;
	}
	UINT DoGetNewCount()
	{
		return sizeof(NEW_NAME) / sizeof(NEW_NAME[0]);
	}
	BOOL DoGetNewName(UINT what, LPTSTR buffer)
	{
		lstrcpyn(buffer, NEW_NAME[what], MAX_PATH);
		return TRUE;
	}
	UINT DoGetFilterCount()
	{
		return 0;
	}
	BOOL DoGetFilterName(UINT what, LPTSTR buffer)
	{
		return FALSE;
	}
};

HACCEL CView::s_hAccelTable;

extern "C" __declspec(dllexport) BOOL TabletInitialize(ITablet* pTablet)
{
	theTablet = pTablet;
	CView::Init();

	(new CFactory)->Create(pTablet->GetWindow(WINDOW_FACTORY));
	(new CSideBar)->Create(pTablet->GetWindow(WINDOW_SIDEBAR), CWindow::rcDefault, NULL, theTablet->GetControlStyle(CONTROL_TREEVIEW));

	return TRUE;
}

extern "C" __declspec(dllexport) void TabletTerminate()
{
	CView::Term();
}

BOOL APIENTRY DllMain(HANDLE hModule, DWORD  ul_reason_for_call, LPVOID)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
		break;
	case DLL_PROCESS_DETACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
		break;
	}
    return TRUE;
}
