// SideBar.h
#pragma once

typedef CWinTraitsOR < WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, WS_EX_CLIENTEDGE> CSideBarTraits;

class CSideBar :
	public CFileTreeCtrlImpl<CSideBar, CFileTreeCtrlItem, CTreeViewCtrl, CSideBarTraits>,
	public CViewCommands<CSideBar>
{
	typedef CFileTreeCtrlImpl<CSideBar, CFileTreeCtrlItem, CTreeViewCtrl, CSideBarTraits>	baseClass;

public:
	DECLARE_WND_SUPERCLASS(_T("FolderBar"), GetWndClassName())

	static LPCTSTR GetWndCaption()
	{
		return _T("tH_");
	}

	void OnFinalMessage(HWND)
	{
		delete this;
	}

public: // CFileTreeCtrlImpl I[o[Ch
	HRESULT OnGetMenuItemName(DWORD wID, HMENU hMenu, LPTSTR name, INT cch)
	{
		if SUCCEEDED(Filer::OnGetMenuItemName(wID, hMenu, name, cch))
			return S_OK;
		else
			return __super::OnGetMenuItemName(wID, hMenu, name, cch);
	}

	UINT PopupContextMenu(HTREEITEM hItem, CMenuHandle popup, CPoint ptScreen)
	{
		Filer::InsertPrivateMenu(popup);
		UINT cmd = theTablet->TrackPopupMenu(popup, ptScreen, m_hWnd);
		if(0x8000 <= cmd)
		{
			CView::New(GetItemParam(hItem)->pShellItem, NULL, Filer::CommandToWindow(cmd));
		}
		return cmd;
	}

	STDMETHODIMP GetControlWindow(UINT id, HWND * lphwnd)
	{
		if(lphwnd == NULL)
			return E_POINTER;
		if(FCW_STATUS == id)
		{
			*lphwnd = theTablet->GetWindow(WINDOW_STATUSBAR);
			return S_OK;
		}
		return E_NOTIMPL;
	}

	void OnItemReturn(HTREEITEM hItem)
	{
		CFileTreeCtrlItem* pItem = GetItemParam(hItem);
		if(!pItem)
			return;
		if(CKeyboard::IsPressed(VK_CONTROL))
		{	// Ctrl => V^uŊJ
			CView::New(pItem->pShellItem, NULL, WINDOW_PANE_ACTIVE);
		}
		else if(CKeyboard::IsPressed(VK_SHIFT))
		{	// Shift => VyCŊJ
			UINT nPane = theTablet->CountElements(WINDOW_PANESPLITTER);
			if(nPane < MAX_PANE_COUNT)
				CView::New(pItem->pShellItem, NULL, (WindowID)(WINDOW_PANE_FIRST+nPane));
			else // ɃyC͍ő吔JĂBdȂ̂ŁAy̐V^uŊJB
				CView::New(pItem->pShellItem, NULL, WINDOW_PANE_ACTIVE);
		}
		else
		{
			// ݃ANeBuȃr[FileView̏ꍇ̂݁B
			HWND hView = theTablet->GetWindow(WINDOW_VIEW_ACTIVE);
			if(CView::IsInstance(hView))
			{	// ݃ANeBuȃ^uFileViewB
				// ̏ꍇ́AłɃANeBuȃ^ũtH_̓c[ƈvĂ͂B
				// PɃr[ANeBuɂB
				::SetFocus(hView);
			}
			else
			{
				// ݃ANeBuȃr[FileViewłȂꍇ́AV^uŊJB
				CView* view = CView::New(pItem->pShellItem, NULL, WINDOW_PANE_ACTIVE);
				if(view)
					view->SetFocus();
			}
		}
	}

public: // CViewCommands I[o[Ch
	BOOL PreTranslateMessage(MSG* pMsg)
	{
		if(baseClass::PreTranslateMessage(pMsg))
			return TRUE;
		return FALSE;
	}

	HICON DoGetIcon(UINT type)
	{
		return AtlLoadIconImage(IDR_MAINFRAME, LR_DEFAULTCOLOR | LR_DEFAULTSIZE | LR_SHARED);
	}

public: // bZ[W}bv
	BEGIN_MSG_MAP(CSideBar)
		MESSAGE_HANDLER(WM_CREATE	, OnCreate)
		REFLECTED_NOTIFY_CODE_HANDLER(TVN_SELCHANGED	, OnItemSelected)
		CHAIN_MSG_MAP(CViewCommands<CSideBar>)
		CHAIN_MSG_MAP(baseClass)
	END_MSG_MAP()

//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)

	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		__super::OnCreate(uMsg, wParam, lParam, bHandled);
		bHandled = TRUE;

		// fXNgbvǉ
		HTREEITEM hRoot = AddFolder(CShellItemTask::FromCSIDL(CSIDL_DESKTOP, m_hWnd));
		if(!hRoot)
			return -1;

		if(false/* expand 'My Computer' from the start */)
		{
			HTREEITEM hItem = FindItem(CShellItemTask::FromCSIDL(CSIDL_DRIVES, m_hWnd), hRoot);
			if(hItem)
				Expand(hItem);
		}

		if(true/* expand 'My Document' from the start */)
		{
			HTREEITEM hItem = FindItem(CShellItemTask::FromCSIDL(CSIDL_PERSONAL, m_hWnd), hRoot);
			if(hItem)
				Expand(hItem);
		}
		return 0;
	}

	LRESULT OnItemSelected(int /*idCtrl*/, LPNMHDR pnmh, BOOL& /*bHandled*/)
	{
		TreeNotify* notify = (TreeNotify*)pnmh;
		ParamType* pItem = notify->itemNew.pParam;
		if(pItem)
		{
			// ݃ANeBuȃr[FileView̏ꍇ̂݁B
			HWND hView = theTablet->GetWindow(WINDOW_VIEW_ACTIVE);
			if(CView::IsInstance(hView))
			{	// ݃ANeBuȃ^uFileViewB
				::SendMessage(hView, WM_GOABSOLUTE, 0, (LPARAM)pItem->pShellItem);
			}
		}
		return 0;
	}
};
