// Main.cpp

#include "stdafx.h"

#include "Tablet.h"
using namespace Tablet;
ITablet* theTablet;

#include "WTL/atlscrl.h"
#include "mew/Picture.h"
using namespace mew;

#include "resource.h"
#include "View.h"
/*
const LPCTSTR NEW_NAME[] =
{
};
*/
const LPCTSTR FILTER_NAME[] =
{
	_T("摜t@C [ImageView]|*.bmp;*gif;*.cur;*.emf;*.ico;*.jpg;*.jpeg;*.wmf|"),
};

const LPCTSTR SUIT_EXTENSIONS =
{
	_T("*.bmp;*gif;*.cur;*.emf;*.ico;*.jpg;*.jpeg;*.wmf")
};

class CFactory : public CFactoryImpl<CFactory>
{
public:
	void OnFinalMessage(HWND)
	{
		delete this;
	}

	////////////////////////////////////////////////////////////////////////////////
	// CFactoryCommands

	BOOL DoNew(UINT what, WindowID parent)
	{
		return FALSE;
	}
	INT  DoQuerySuitable(const FileNode* node)
	{
		if(node->IsFile() && PathMatchSpec(node->path, SUIT_EXTENSIONS))
			return SUIT_HIGH;
		else
			return SUIT_NONE;
	}
	BOOL DoOpen(const FileNode* node, WindowID parent)
	{
		CPicture pic;
		if(!pic.LoadFromFile(node->path))
			return FALSE;
		HWND hView = (new CView(node->path, pic))->Create(theTablet->GetWindow(parent));
		return hView != NULL;
	}
	UINT DoGetNewCount()
	{
		return 0;
//		return sizeof(NEW_NAME) / sizeof(NEW_NAME[0]);
	}
	BOOL DoGetNewName(UINT what, LPTSTR buffer)
	{
		return FALSE;
//		lstrcpyn(buffer, NEW_NAME[what], MAX_PATH);
//		return TRUE;
	}
	UINT DoGetFilterCount()
	{
		return sizeof(FILTER_NAME) / sizeof(FILTER_NAME[0]);
	}
	BOOL DoGetFilterName(UINT what, LPTSTR buffer)
	{
		lstrcpyn(buffer, FILTER_NAME[what], MAX_PATH);
		return TRUE;
	}
};

////////////////////////////////////////////////////////////////////////////////

HACCEL CView::s_hAccelTable;

extern "C" __declspec(dllexport) BOOL TabletInitialize(ITablet* pTablet)
{
	theTablet = pTablet;
	CView::Init();

	(new CFactory)->Create(pTablet->GetWindow(WINDOW_FACTORY));

	return TRUE;
}

extern "C" __declspec(dllexport) void TabletTerminate()
{
	CView::Term();
}

BOOL APIENTRY DllMain(HANDLE hModule, DWORD  ul_reason_for_call, LPVOID)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
		break;
	case DLL_PROCESS_DETACH:
		break;
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
		break;
	}
    return TRUE;
}
