// AddressBar.h
#pragma once

// AhXo[ƃqXgǗ܂B

class CAddressBar : public CComboBoxEx
{
private:
	CStdVector<CString>	m_History;

public:
	HWND Create(HWND hWndParent, WORD wID, INT height)
	{
		return __super::Create(hWndParent, CRect(0, 0, 0, height), _T("WINDOW_ADDRESSBAR"), WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS | CBS_DROPDOWN | CBS_AUTOHSCROLL, 0, wID);
	}

	UINT GetCount() const
	{
		return m_History.GetCount();
	}

	LPCTSTR GetAt(UINT index) const
	{
		if(index >= m_History.GetCount())
		{
			ATLTRACE("ERROR: Index out of bounds. CAddressBar::GetAt(%d)\n", index);
			return NULL;
		}
		else
			return m_History[index];
	}

	bool Set(LPCTSTR text)
	{
		if(!IsWindow())
			return false;
		CEdit edit = this->GetEditCtrl();
		if(!edit.IsWindow())
			return false;
		edit.SetWindowText(text);
		return true;
	}

	UINT Add(LPCTSTR path)
	{
		CString str(path);
		CStdVector<CString>::iterator i = std::lower_bound(m_History.begin(), m_History.end(), str);
		if(i == m_History.end() || *i != str)
		{	// VKo^
			i = m_History.insert(i, str);
			//
			if(!IsWindow())
				return -1;
			COMBOBOXEXITEM item = {CBEIF_TEXT};
			item.iItem = i - m_History.begin();
			item.pszText = (LPTSTR)(LPCTSTR)(str);
			item.cchTextMax = str.GetLength();
			InsertItem(&item);
		}
		return i - m_History.begin();

	}
};
