// FactoryPane.h
#pragma once

typedef CWinTraits<WS_CHILD, 0> CFactoryPaneTraits;

class CFactoryPane : public CPaneImpl<CFactoryPane, CWindow, CFactoryPaneTraits>
{
private:
	CStdVector<CFactoryWindow>	m_Items;

public: // I[o[Ch
	BOOL PreTranslateMessage(MSG* pMsg)
	{
		return FALSE;
	}
	UINT DoCountElements()
	{
		return m_Items.GetCount();
	}
	HWND DoGetElement(UINT index)
	{
		if(index == -1) index = 0;
		if(index >= m_Items.GetCount())
			return NULL;
		return m_Items.GetAt(index);
	}
	INT  DoGetActiveIndex()
	{
		return -1;
	}
	INT  DoSetActiveIndex(INT index)
	{
		return -1;
	}
	BOOL DoAddElement(CFactoryWindow view, UINT index)
	{
		if(index == -1)
			m_Items.Add(view);
		else
			m_Items.InsertAt(index, view);
		return TRUE;
	}
	BOOL DoMoveElement(CFactoryWindow view, UINT index)
	{
		return FALSE;
	}
	BOOL DoDeleteElement(UINT index)
	{
		if(index >= m_Items.GetCount())
			return FALSE;
		m_Items.RemoveAt(index);
		return TRUE;
	}
	void OnNameChanged(CFactoryWindow view)
	{
	}

public: // bZ[W}bv
	BEGIN_MSG_MAP(CFactoryPane)
//		MESSAGE_HANDLER(WM_CREATE		, OnCreate)
//		MESSAGE_HANDLER(WM_COMMAND		, OnCommand)
		MESSAGE_HANDLER(WM_PARENTNOTIFY	, OnParentNotify)
//		MESSAGE_HANDLER(WM_TABLET_NAMECHANGED	, OnNameChanged)
		CHAIN_MSG_MAP(__super)
	END_MSG_MAP()

	LRESULT OnParentNotify(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		UINT what = LOWORD(wParam);
		HWND hChild;
		switch(what)
		{
		case WM_CREATE:
			hChild = (HWND)lParam;
			if(::GetParent(hChild) == m_hWnd)
				DoAddElement(hChild, -1);
			break;
		case WM_DESTROY:
			hChild = (HWND)lParam;
			if(::GetParent(hChild) == m_hWnd)
			{
				UINT nCount = m_Items.GetCount();
				for(UINT i = 0; i < nCount; i++)
				{
					if(m_Items[i] == hChild)
						return DoDeleteElement(i);
				}
				return FALSE;
			}
			break;
		default:
			break;
		}
		bHandled = FALSE;
		return 0;
	}
};
