// MenuBar.h
#pragma once

/////////////////////////////////////////////////////////////////////////////

#ifdef USING_XP_MENU

#include "WTL/atlctrlxp.h"

class CMenuBar : public CCommandBarXPCtrl
{
private:
	typedef CCommandBarXPCtrl	baseClass;

public:
	HWND Create(HWND hWndParent, WORD wID)
	{
		baseClass::Create(hWndParent, rcDefault, _T("WINDOW_MENUBAR"), ATL_SIMPLE_XP_CMDBAR_PANE_STYLE, 0, wID);
		AttachMenu(::GetMenu(hWndParent));
		LoadImages(IDR_MAINFRAME);
		::SetMenu(hWndParent, NULL);
		return m_hWnd;
	}
	void PostCreate(HWND hToolBar)
	{
		Prepare();
		AddToolbar(hToolBar);
	}
	BOOL TrackPopupMenu(HMENU hMenu, UINT uFlags, int x, int y, LPTPMPARAMS lpParams)
	{
		return baseClass::TrackPopupMenu(hMenu, uFlags, x, y, lpParams);
	}
};

/////////////////////////////////////////////////////////////////////////////

#else

class CMenuBar : public CCommandBarCtrl
{
private:
	typedef CCommandBarCtrl	baseClass;

public:
	HWND Create(HWND hWndParent, WORD wID)
	{
		baseClass::Create(hWndParent, rcDefault, _T("WINDOW_MENUBAR"), ATL_SIMPLE_CMDBAR_PANE_STYLE, 0, wID);
		AttachMenu(::GetMenu(hWndParent));
		LoadImages(IDR_MAINFRAME);
		::SetMenu(hWndParent, NULL);
		return m_hWnd;
	}
	void PostCreate(HWND hToolBar)
	{
	}
	BOOL TrackPopupMenu(HMENU hMenu, UINT uFlags, int x, int y, LPTPMPARAMS lpParams)
	{
		return baseClass::TrackPopupMenu(hMenu, uFlags, x, y, lpParams);
	}
};

/////////////////////////////////////////////////////////////////////////////

#endif
