// NewDialog.h
#pragma once

class CNewDialog : public CDialogImpl<CNewDialog>
{
private:
	int			m_SelectedIndex;
	CListBox	m_ListBox;

public:
	enum { IDD = IDD_NEW };

	CNewDialog()
	{
		m_SelectedIndex = 0;
	}

	BEGIN_MSG_MAP(CNewDialog)
		MESSAGE_HANDLER(WM_INITDIALOG	, OnInitDialog)
		MESSAGE_HANDLER(WM_DESTROY		, OnDestroy)
		COMMAND_ID_HANDLER(IDOK			, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL		, OnCancel)
	//	CHAIN_MSG_MAP(__super) // not needed
	END_MSG_MAP()

//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		// Xg{bNX̏
		m_ListBox.Attach(GetDlgItem(IDC_NEW_LIST));
		UINT size = theTablet->CountElements(WINDOW_FACTORY);
		for(UINT i = 0; i < size; i++)
		{
			CFactoryWindow fac = theTablet->GetElement(WINDOW_FACTORY, i);
			UINT kinds = fac.GetNewCount();
			for(UINT j = 0; j < kinds; j++)
			{
				TCHAR buffer[MAX_PATH];
				if(fac.GetNewName(j, buffer))
				{
					int index = m_ListBox.AddString(buffer);
					m_ListBox.SetItemData(index, MAKELPARAM(i, j));
				}
			}
		}
		m_ListBox.SetCurSel(m_SelectedIndex);
		CenterWindow(GetParent());
		return TRUE;
	}

	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		m_ListBox.Detach();
		return 0;
	}

	LRESULT OnOK(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		m_SelectedIndex = m_ListBox.GetCurSel();
		if(m_SelectedIndex == LB_ERR)
			return 0;
		EndDialog(IDOK);
		// ÎŁAIĂt@Ng쐬B
		DWORD param = m_ListBox.GetItemData(m_SelectedIndex);
		UINT document = LOWORD(param);
		UINT index    = HIWORD(param);
		CFactoryWindow fac = theTablet->GetElement(WINDOW_FACTORY, document);
		fac.New(index);
		return 0;
	}

	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		m_SelectedIndex = 0;
		EndDialog(IDCANCEL);
		return 0;
	}
};
