// PaneImpl.h
#pragma once

template < class T > class ATL_NO_VTABLE CPaneCommands
{
public: // Iy[V
	UINT CountElements()						{ return static_cast<T*>(this)->DoCountElements(); }
	HWND GetElement(UINT index)					{ return static_cast<T*>(this)->DoGetElement(index); }
	HWND GetActiveElement()						{ return GetElement(-1); }
	INT  GetActiveIndex()						{ return static_cast<T*>(this)->DoGetActiveIndex(); }
	INT  SetActiveIndex(INT index)				{ return static_cast<T*>(this)->DoSetActiveIndex(); }
	BOOL AddElement(HWND hWnd, UINT index = -1)	{ return static_cast<T*>(this)->DoAddElement(hWnd, index); }
	BOOL MoveElement(HWND hWnd, UINT index)		{ return static_cast<T*>(this)->DoMoveElement(hWnd, index); }
	BOOL DeleteElement(UINT index)				{ return static_cast<T*>(this)->DoDeleteElement(index); }

protected:
	void NotifyElementChange(ElementChange what, HWND hWnd)
	{
		::SendMessage(theTablet->GetWindow(WINDOW_MAINFRAME), WM_TABLET_ELEMENTCHANGE, (WPARAM)what, (LPARAM)hWnd);
	}

public: // I[o[Ch
//	BOOL PreTranslateMessage(MSG* pMsg)
//	UINT DoCountElements()
//	HWND DoGetElement(UINT index)
//	BOOL DoAddElement(HWND hWnd, UINT index = -1)
//	BOOL DoMoveElement(HWND hWnd, UINT index)
//	BOOL DoDeleteElement(UINT index)
//	void OnNameChanged(CCommonWindow view);

public: // bZ[W}bv
	BEGIN_MSG_MAP(CPaneCommands)
		MESSAGE_LAMBDA(WM_TABLET_PRETRANSLATE	, { lResult = static_cast<T*>(this)->PreTranslateMessage((MSG*)lParam); })
		MESSAGE_LAMBDA(WM_TABLET_COUNTELEMENTS	, { lResult = static_cast<T*>(this)->DoCountElements(); })
		MESSAGE_LAMBDA(WM_TABLET_GETACTIVEINDEX	, { lResult = static_cast<T*>(this)->DoGetActiveIndex(); })
		MESSAGE_LAMBDA(WM_TABLET_SETACTIVEINDEX	, { lResult = static_cast<T*>(this)->DoSetActiveIndex(wParam); })
		MESSAGE_LAMBDA(WM_TABLET_GETELEMENT		, { lResult = (LRESULT)static_cast<T*>(this)->DoGetElement(wParam); })
		MESSAGE_LAMBDA(WM_TABLET_ADDELEMENT		, { lResult = static_cast<T*>(this)->DoAddElement((HWND)lParam, (UINT)wParam); })
		MESSAGE_LAMBDA(WM_TABLET_MOVEELEMENT	, { lResult = static_cast<T*>(this)->DoMoveElement((HWND)lParam, (UINT)wParam); })
		MESSAGE_LAMBDA(WM_TABLET_DELETEELEMENT	, { lResult = static_cast<T*>(this)->DoDeleteElement((UINT)wParam); })
		MESSAGE_LAMBDA(WM_TABLET_NAMECHANGED	, { static_cast<T*>(this)->OnNameChanged((HWND)lParam);})
	END_MSG_MAP()
};

template < class T, class TBase = CWindow, class TWinTraits = CControlWinTraits >
class ATL_NO_VTABLE CPaneImpl : public CWindowImpl<T, TBase, TWinTraits>, public CPaneCommands<T>
{
public:
	BEGIN_MSG_MAP(CPaneImpl)
		CHAIN_MSG_MAP(CPaneCommands<T>);
	END_MSG_MAP()
};
