// PaneSplitter.h
#pragma once

#include "ViewPane.h"

class CPaneSplitter :
	public CMultiSplitterWindowImpl<CPaneSplitter>,
	public CPaneCommands<CPaneSplitter>
{
	typedef CMultiSplitterWindowImpl<CPaneSplitter>	baseClass; 
	typedef CPaneCommands<CPaneSplitter>			baseCommands;
public:
	DECLARE_WND_CLASS_EX(_T("PaneSplitter"), CS_DBLCLKS, COLOR_WINDOW)

public: // Iy[V
	CPaneWindow GetElement(UINT index)	{ return DoGetElement(index); }
	CPaneWindow GetActiveElement()		{ return DoGetElement(-1); }

	bool AddPane()
	{
		return EnsurePaneCount(CountElements()+1);
	}

	// count̃yC݂邱Ƃۏ؂B
	bool EnsurePaneCount(UINT count)
	{
		if(count > MAX_PANE_COUNT)
			return false;
		UINT current = GetPaneCount();
		if(count > current)
		{
			SetPaneCount(count);
			for(UINT i = current; i < count; i++)
			{
				ATLASSERT(!GetPane(i));
				CViewPane* pViewPane = new CViewPane();
				pViewPane->Create(m_hWnd, rcDefault, _T("WINDOW_PANE"));
				SetPane(i, pViewPane->m_hWnd, false);
			}
			TilePanes();
		}
		return true;
	}

public: // I[o[Ch - CPaneCommands
	BOOL PreTranslateMessage(MSG* pMsg)
	{
		return FALSE;
	}
	UINT DoCountElements()
	{
		return GetPaneCount();
	}
	HWND DoGetElement(UINT index)
	{
		if(index == -1)
			return GetPane(GetActivePane());
		if(index >= GetPaneCount())
			return NULL;
		return GetPane(index);
	}
	INT  DoGetActiveIndex()
	{
		return GetActivePane();
	}
	INT  DoSetActiveIndex(INT index)
	{
		INT nCount = DoCountElements();
		if(nCount == 0)
			return -1;
		INT i = (index >= 0) ? (index % nCount) : (nCount - (-index) % nCount);
		SetActivePane(i);
		return GetActivePane();
	}
	BOOL DoAddElement(CPaneWindow view, UINT index)
	{
		return FALSE;
	}
	BOOL DoMoveElement(CPaneWindow view, UINT index)
	{
		return FALSE;
	}
	BOOL DoDeleteElement(UINT index)
	{
		return RemovePane(index);
	}
	void OnNameChanged(CPaneWindow view)
	{
	}

public: // I[o[Ch - CSplitterWindowExImpl
	void OnActivePaneChange(INT index)
	{
		CWindow pane = GetPane(index);
		if(pane)
			NotifyElementChange(CHANGE_PANE_ACTIVE, pane);
	}
	bool OnSetPane(INT index, HWND hWnd)
	{
		NotifyElementChange(CHANGE_PANE_ADD, hWnd);
		return true;
	}
	bool OnRemovePane(INT index)
	{
		NotifyElementChange(CHANGE_PANE_DELETE, GetPane(index));
		return true;
	}
};
