// SidePane.h
#pragma once

class CSidePane : public CTabbedPane
{
private:
	CStdVector<CCommonWindow> m_Views;

public:
	CSidePane()
	{
		SetIconSize(CSize(32, 32));
	}

	void ToggleTabVisible(CCommonWindow view)
	{
		INT index = GetTab(view);
		if(index < 0)
		{
			INT insert = 0;
			for(size_t i = 0; i < m_Views.GetCount(); i++)
			{
				if(m_Views[i] == view)
				{
					TCHAR longName[MAX_PATH];
					view.GetNames(NULL, longName);
					AddTab(view, NULL, longName, view.GetIcon(true), insert);
					SetCurSel(i);
					break;
				}
				else if(GetTab(m_Views[i]) >= 0)
				{	// ̕@ƁAO(N^2)̎Ԃ邪cc
					// ^u͐낤̂ŋĂB
					insert++;
				}
			}
		}
		else
		{
			RemoveTab(view);
			view.ShowWindow(SW_HIDE);
		}
	}

	BEGIN_MSG_MAP(CSidePane)
		NOTIFY_CODE_LAMBDA(CTCN_CLOSE	, { ::PostMessage(theTablet->GetWindow(WINDOW_MAINFRAME), WM_COMMAND, MAKEWPARAM(ID_VIEW_SIDEBAR, 0), 0); } )
		CHAIN_MSG_MAP(__super)
	END_MSG_MAP()

protected:
	virtual BOOL DoAddElement(CCommonWindow view, UINT index)
	{
		TCHAR name[MAX_PATH];
		view.GetNames(NULL, name);
		UINT insert = AddTab(view, NULL, name, view.GetIcon(true), index);
		m_Views.InsertAt(insert, view);
		NotifyElementChange(CHANGE_SIDEBAR_ADD, view);
		return TRUE;
	}

	virtual BOOL DoMoveElement(CCommonWindow view, UINT index)
	{
		MessageBox(_T("DoMoveElement"), _T("NOT_IMPL"));
		NotifyElementChange(CHANGE_SIDEBAR_MOVE, view);
		return TRUE;
	}

	virtual BOOL DoDeleteElement(UINT index)
	{
		if(index >= CountElements())
			return FALSE;
		CCommonWindow view = GetItem(index)->GetTabView();
		for(size_t i = 0; i < m_Views.GetCount(); i++)
		{
			if(m_Views[i] == view)
			{
				m_Views.RemoveAt(i);
				GetTabCtrl().DeleteItem(i);
				NotifyElementChange(CHANGE_SIDEBAR_DELETE, view);
				return TRUE;
			}
		}
		return FALSE;
	}

	virtual void OnNameChanged(CCommonWindow view)
	{
		if(ItemType* pItem = GetItem(view))
		{
			TCHAR longName[MAX_PATH];
			view.GetNames(NULL, longName);
			HICON hIcon = view.GetIcon(true);
			pItem->SetToolTip(longName);
			pItem->SetIcon(hIcon);
			UpdateLayout();
		}
	}

	virtual void OnTabMouse(const NMCTCMOUSE& mouse, CCommonWindow view, CPoint ptScreen)
	{
		switch(mouse.uMsg)
		{
		case WM_RBUTTONUP:
			if(view)
			{	// ^ȕ̉ENbŃuReLXgj[v
//				TabContextMenu(view, ptScreen);
				CMenu menu;
				menu.LoadMenu(IDR_CONTEXT);
				CMenuHandle popup = menu.GetSubMenu(1);
				UINT cmd = theTablet->TrackPopupMenu(popup, ptScreen, m_hWnd);
				switch(cmd)
				{
				case 0: // Cancel
					break;
				case ID_VIEW_SIDEBAR:
					ToggleTabVisible(view);
					break;
				default: // łȂR}hȂ̂Őeɓ]B
					::PostMessage(GetTopLevelParent(), WM_COMMAND, MAKEWPARAM(cmd, 0), 0);
				}
			}
			else if(mouse.hit.flags == CTCHT_NOWHERE)
			{	// 󔒕̉ENbŃuReLXgj[v
				CMenu popup;
				popup.CreatePopupMenu();
				for(size_t i = 0; i < m_Views.GetCount(); i++)
				{
					TCHAR longName[MAX_PATH];
					m_Views[i].GetNames(NULL, longName);
					DWORD flags = MF_STRING | (GetTab(m_Views[i]) >= 0 ? MF_CHECKED : 0);
                    popup.AppendMenu(flags, i+1, longName);
				}
				UINT cmd = theTablet->TrackPopupMenu(popup, ptScreen, m_hWnd);
				if(cmd > 0)
				{
					ToggleTabVisible(m_Views[cmd-1]);
				}
			}
			break;
		}
	}
};
