// ViewPane.h
#pragma once

class CViewPane : public CTabbedPane
{
public:
	CViewPane()
	{
	}

	virtual void OnFinalMessage(HWND)
	{
		delete this;
	}

public:
	////////////////////////////////////////////////////////////////////////////////
	// Message Map

	BEGIN_MSG_MAP(CViewPane)
		COMMAND_ID_LAMBDA(ID_FILE_CLOSE	, { OnCloseCommand(); } )
		NOTIFY_CODE_LAMBDA(CTCN_CLOSE	, { OnCloseCommand(); } )
		NOTIFY_CODE_HANDLER(CTCN_SELCHANGE	, OnSelChange)
		CHAIN_MSG_MAP(__super)
	END_MSG_MAP()

//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)

private:
	// 삪xBuv{^AłĂB
	// `悪x̂A̕H
	void OnCloseCommand()
	{
		if(CountElements() > 0)
		{	// r[cĂꍇ݂͌̃r[B
			::PostMessage(m_hWndActive, WM_CLOSE, 0, 0);
		}
		else
		{	// r[ꍇ͎gB
			// Ō̃yCŖȂ΁AyĈB
			if(theTablet->CountElements(WINDOW_PANESPLITTER) > 1)
				PostMessage(WM_CLOSE);
		}
	}

	void TabContextMenu(CCommonWindow view, CPoint ptScreen)
	{
		const UINT COMMAND_FIRST = 0x8000;
		UINT nPanes = theTablet->CountElements(WINDOW_PANESPLITTER);
		CMenu popup;
		popup.CreatePopupMenu();
		popup.AppendMenu(0, ID_FILE_CLOSE, _T("(&C)"));
		popup.AppendMenu(MF_SEPARATOR);
		for(UINT i = 0; i < nPanes; i++)
		{
			TCHAR buffer[128];
			wsprintf(buffer, _T(" &%d yCֈړ"), i+1);
			// gւ̈ړ͖B
			UINT flags = (theTablet->GetElement(WINDOW_PANESPLITTER, i) == m_hWnd) ? MF_GRAYED : 0;
			popup.AppendMenu(flags, COMMAND_FIRST + i, buffer);
		}
		if(nPanes < MAX_PANE_COUNT)
			popup.AppendMenu(0, COMMAND_FIRST+nPanes, _T("VyCֈړ(&0)"));
		UINT cmd = theTablet->TrackPopupMenu(popup, ptScreen, m_hWnd);
		switch(cmd)
		{
		case 0: // Cancel
			break;
		case ID_FILE_CLOSE:
			view.PostMessage(WM_CLOSE);
			break;
		default:
			if(COMMAND_FIRST <= cmd && cmd <= COMMAND_FIRST+nPanes)
				theTablet->MoveElement(view, cmd-COMMAND_FIRST, -1);
		}
	}

	void NonTabContextMenu(CPoint ptScreen)
	{
		CMenu menu;
		menu.LoadMenu(IDR_CONTEXT);
		CMenuHandle popup = menu.GetSubMenu(0);
		// TODO: j[̐B
		// popup.CheckMenuItem(ID_PANE_MAXIMIZE, UIxxx);
		UINT cmd = theTablet->TrackPopupMenu(popup, ptScreen, m_hWnd);
		switch(cmd)
		{
		case 0: // Cancel
			break;
		case ID_PANE_CLOSE:
			while(m_hWndActive)
			{
				HWND hWnd = m_hWndActive;
				::SendMessage(hWnd, WM_CLOSE, 0, 0);
				if(::IsWindow(hWnd))
				{	// WM_CLOSE ̓LZꂽ
					break;
				}
			}
			if(m_hWndActive == NULL && theTablet->CountElements(WINDOW_PANESPLITTER) > 1)
			{	// Ō̃yCŖȂ΁AyĈB
				PostMessage(WM_CLOSE);
			}
			break;
		case ID_PANE_MAXIMIZE:
		case ID_PANE_NEW:
		case ID_PANE_DIRECTION:
			::PostMessage(GetTopLevelParent(), WM_COMMAND, MAKEWPARAM(cmd, 0), 0);
			break;
		default:
			ATLASSERT(!"NonTabContextMenu: m̃R}h");
		}
	}

protected:
	virtual BOOL DoAddElement(CCommonWindow view, UINT index)
	{
		if(view.GetParent() != m_hWnd)
			view.SetParent(m_hWnd);
		TCHAR shortName[MAX_PATH], longName[MAX_PATH];
		view.GetNames(shortName, longName);
		UINT insert = AddTab(view, shortName, longName, view.GetIcon(false), index);
		SetCurSel(insert);
		NotifyElementChange(CHANGE_VIEW_ADD, view);
		return TRUE;
	}

	virtual BOOL DoMoveElement(CCommonWindow view, UINT index)
	{
		MessageBox(_T("DoMoveElement"), _T("NOT_IMPL"));
		NotifyElementChange(CHANGE_VIEW_MOVE, view);
		return TRUE;
	}

	virtual BOOL DoDeleteElement(UINT index)
	{
		if(index >= CountElements())
			return FALSE;
		CCommonWindow view = GetItem(index)->GetTabView();
		if(!GetTabCtrl().DeleteItem(index))
		{
			ATLTRACE("CViewPane::DoDeleteView(%08X) failed.\n", (HWND)view);
			return FALSE;
		}
		NotifyElementChange(CHANGE_VIEW_DELETE, view);
		return TRUE;
	}

	virtual void OnNameChanged(CCommonWindow view)
	{
		INT index = GetTab(view);
		if(ItemType* pItem = GetItem(index))
		{
			TCHAR shortName[MAX_PATH], longName[MAX_PATH];
			view.GetNames(shortName, longName);
			HICON hIcon = view.GetIcon(false);
			pItem->SetText(shortName);
			pItem->SetToolTip(longName);
			pItem->SetIcon(hIcon);
			if(index == GetTabCtrl().GetCurSel())
				NotifyElementChange(CHANGE_VIEW_ACTIVE, view);
			UpdateLayout();
		}
	}
	
	virtual void OnTabMouse(const NMCTCMOUSE& mouse, CCommonWindow view, CPoint ptScreen)
	{
		switch(mouse.uMsg)
		{
		case WM_LBUTTONDBLCLK:
			if(mouse.hit.flags == CTCHT_NOWHERE)
			{	// 󔒕̃_uNbNVO[h̐؂ւɊUĂ݂B
				// LvṼ_uNbNōő剻؂ւ̂ƑΉĂB
				::PostMessage(GetTopLevelParent(), WM_COMMAND, MAKEWPARAM(ID_PANE_MAXIMIZE, 0), 0);
			}
			break;
		case WM_MBUTTONUP:
			if(view)
			{	// NbŃuv
				view.PostMessage(WM_CLOSE);
			}
			break;
		case WM_RBUTTONUP:
			if(view)
			{	// ^ȕ̉ENbŃuReLXgj[v
				TabContextMenu(view, ptScreen);
			}
			else if(mouse.hit.flags == CTCHT_NOWHERE)
			{	// 󔒕̉ENbŃuReLXgj[v
				NonTabContextMenu(ptScreen);
			}
			break;
		}
	}

	LRESULT OnSelChange(int /*idCtrl*/, LPNMHDR pnmh, BOOL& bHandled)
	{
		NMCTC2ITEMS* items = (NMCTC2ITEMS*)pnmh;
		ItemType* pItem = GetItem(items->iItem2);
		NotifyElementChange(CHANGE_VIEW_ACTIVE, pItem ? pItem->GetTabView() : NULL);
		bHandled = FALSE;
		return 0;
	}
};
