// Main.cpp

#include "stdafx.h"

#include "Tablet.h"
using namespace Tablet;
ITablet* theTablet;

#define ID_VIEW_FONT_SMALLEST	(ID_VIEW_SHOW_FIRST+0)
#define ID_VIEW_FONT_SMALL		(ID_VIEW_SHOW_FIRST+1)
#define ID_VIEW_FONT_NORMAL		(ID_VIEW_SHOW_FIRST+2)
#define ID_VIEW_FONT_LARGE		(ID_VIEW_SHOW_FIRST+3)
#define ID_VIEW_FONT_LARGEST	(ID_VIEW_SHOW_FIRST+4)

#include "resource.h"
#include "mew/MessageMap.h"
#include "mew/WebBrowser.h"
using namespace mew;

#include "View.h"
#include "SideBar.h"

const LPCTSTR NEW_NAME[] =
{
	_T("URL [Browser]"),
};

const LPCTSTR FILTER_NAME[] =
{
	_T("HTMLt@C [Browser]|*.htm;*.html;*.shtml;*.mht;*.xml;*.xsl;*.url|"),
};

const LPCTSTR SUIT_EXTENSIONS =
{
	_T("*.htm;*.html;*.shtml;*.mht;*.xml;*.xsl;*.url")
};

const LPCTSTR SUIT_SCHEME =
{
	_T("http:*;https:*;ftp*")_T(";gj:*;ga:*;ej:*;je:*;ja:*")
};

// ƎURLXL[}̏ꍇ́ǍURLɕϊB
bool CheckSearchUrl(CStringA& out, LPCTSTR url)
{
	int len = UrlFindScheme(url);
	if(len < 0)
		return false;
	const LPCTSTR LIST[][2] =
	{
		_T("ga:"), _T("http://www.google.co.jp/search?ie=UTF-8&oe=UTF-8&hl=ja&lr=&q="),				// GoogleAll
		_T("gj:"), _T("http://www.google.co.jp/search?ie=UTF-8&oe=UTF-8&hl=ja&lr=lang_ja&q="),		// GoogleJP
		_T("ej:"), _T("http://jiten.www.infoseek.co.jp/Eigo?pg=result_e.html&sm=1&col=EW&qt="),		// infoseekpa
		_T("je:"), _T("http://jiten.www.infoseek.co.jp/Eigo?pg=result_w.html&sm=1&col=WE&qt="),		// infoseekap
		_T("ja:"), _T("http://jiten.www.infoseek.co.jp/Kokugo?pg=result_k.html&sm=1&col=KO&qt="),	// infoseek
	};
	const size_t LENGTH = sizeof(LIST)/sizeof(LIST[0]);
	for(size_t i = 0; i < LENGTH; i++)
	{
		if(StrCmpN(url, LIST[i][0], len) == 0)
		{
			CStringA escaped;
			EscapeToCString(escaped, CT2CW(url+len+1));
			out.Preallocate(lstrlen(LIST[i][1]) + escaped.GetLength());
			out = LIST[i][1];
			out += escaped;
			return true;
		}
	}
	return false;
}

class CFactory : public CFactoryImpl<CFactory>
{
public:
	void OnFinalMessage(HWND)
	{
		delete this;
	}

	////////////////////////////////////////////////////////////////////////////////
	// CFactoryCommands

	BOOL DoNew(UINT what, WindowID parent)
	{
		return CView::New(parent, NULL) != NULL;
	}
	INT  DoQuerySuitable(const FileNode* node)
	{
		if(!node->path)
			return SUIT_NONE;
		if(node->IsFile() && PathMatchSpec(node->path, SUIT_EXTENSIONS))
		{	// Ήgq̃t@C
			return SUIT_HIGH;
		}
		else if(PathIsURL(node->path))
		{	// ΉURL
			if(PathMatchSpec(node->path, SUIT_SCHEME))
				return SUIT_HIGH;
			else
				return SUIT_NONE;
		}
		else if(node->path && !node->pidl)
		{	// vgRw̖URLȁH "www.google.com" ȂǁBƂ肠J邩ȂB
			return SUIT_LOW;
		}
		else
			return SUIT_NONE;
	}
	BOOL DoOpen(const FileNode* node, WindowID parent)
	{
		if(!node->path)
			return FALSE;
		CStringA buffer;
		if(CheckSearchUrl(buffer, node->path))
			return CView::New(parent, CA2CT(buffer)) != NULL;
		else
			return CView::New(parent, node->path) != NULL;
	}
	UINT DoGetNewCount()
	{
		return sizeof(NEW_NAME) / sizeof(NEW_NAME[0]);
	}
	BOOL DoGetNewName(UINT what, LPTSTR buffer)
	{
		lstrcpyn(buffer, NEW_NAME[what], MAX_PATH);
		return TRUE;
	}
	UINT DoGetFilterCount()
	{
		return sizeof(FILTER_NAME) / sizeof(FILTER_NAME[0]);
	}
	BOOL DoGetFilterName(UINT what, LPTSTR buffer)
	{
		lstrcpyn(buffer, FILTER_NAME[what], MAX_PATH);
		return TRUE;
	}
};

////////////////////////////////////////////////////////////////////////////////

class CNavigateFitler : public INavigateFilter
{
	bool FilterURL(LPCTSTR strURL)
	{
		if(StrCmpNI(strURL, _T("mailto:"), 7) == 0) // 7 == lstrlen("mailto:")
		{
			return false;
		}
		return true;
	}
	bool FilterTitle(LPCTSTR strTitle)
	{
		return true;
	}
	bool FilterStatusText(LPCTSTR strText)
	{
		// NȂ΁A"http://..."
		// _E[hȂ΁A"icnځjhttp://... _E[hĂ܂"
		// ȊOJavaScriptɂזbZ[WH
		// Ƃ肠AȒPȃtB^OĂ݂B
		if(lstrlen(strText) == 0)
			return true;
		const LPCTSTR FILTER[] =
		{
			_T("http"),
			_T("java"),
			_T("file"),
			_T("mailto"),
			_T("ftp"),
			_T("ڑ")
		};
		for(size_t i = 0; i < sizeof(FILTER)/sizeof(FILTER[0]); i++)
		{
			if(StrStr(strText, FILTER[i]))
				return true;
		}
		return false;
	}
};

////////////////////////////////////////////////////////////////////////////////

CNavigateFitler theFilter;
HACCEL CView::s_hAccelTable;
INavigateFilter* CView::s_pFilter;

// CAxWindow ĝɁA
// E_Module.Init(NULL, hInstance, &guid) guid|CgB
// EAtlAxWinInit()
// KvȂ悤B
// AAtlAxWinInit() ̓t[[NłĂԂ炵AIɌĂ΂ȂĂ̊ԂɂĂ΂ۂB
// guid ɂẮAEBU[h쐬R[hƂȂĂĂ̂ccH

CComModule _Module;
[ uuid("F7C091F1-EAC2-4A90-AA92-5776EE68F4AE") ] class CModule;

extern "C" __declspec(dllexport) BOOL TabletInitialize(ITablet* pTablet)
{
	theTablet = pTablet;
	_Module.Init(NULL, GetModuleHandle(NULL), &__uuidof(CModule));
	AtlAxWinInit();
	CView::Init(&theFilter);

	(new CFactory)->Create(pTablet->GetWindow(WINDOW_FACTORY));
	(new CSideBar)->Create(pTablet->GetWindow(WINDOW_SIDEBAR), CWindow::rcDefault, NULL, theTablet->GetControlStyle(CONTROL_TREEVIEW));

	return TRUE;
}

extern "C" __declspec(dllexport) void TabletTerminate()
{
	CView::Term();
	_Module.Term();
}

BOOL APIENTRY DllMain(HANDLE hModule, DWORD  ul_reason_for_call, LPVOID)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
		break;
	case DLL_PROCESS_DETACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
		break;
	}
    return TRUE;
}
