// TabletBase.h
#pragma once

namespace Tablet
{
	////////////////////////////////////////////////////////////////////////////////
	// \́E񋓎q

	struct FileEntry
	{
		enum Type
		{
			TYPE_NONE,
			TYPE_PATHA,
			TYPE_PATHW,
			TYPE_ITEMIDLIST,
			TYPE_CIDA,
			TYPE_HDROP,
#ifdef _UNICODE
			TYPE_PATH	= TYPE_PATHW,
#else
			TYPE_PATH	= TYPE_PATHA,
#endif
		};
		Type type;
		union
		{
			LPCSTR			pPathA;
			LPCWSTR			pPathW;
			LPCTSTR			pPath;
			LPCITEMIDLIST	pIDL;
			const CIDA*		pCIDA;
			HDROP			hDrop;
		};

		FileEntry(LPCSTR        entry) : type(TYPE_PATHA)     , pPathA(entry)	{}
		FileEntry(LPCWSTR       entry) : type(TYPE_PATHW)     , pPathW(entry)	{}
		FileEntry(LPCITEMIDLIST entry) : type(TYPE_ITEMIDLIST), pIDL(entry)		{}
		FileEntry(const CIDA*   entry) : type(TYPE_CIDA)      , pCIDA(entry)	{}
		FileEntry(HDROP			entry) : type(TYPE_HDROP)     , hDrop(entry)	{}
	};

	struct FileNode
	{
		LPCITEMIDLIST	pidl;	// NULL̏ꍇ́AURLȂǂ̔񃍁[J\[Xł\܂B
		LPCTSTR			path;	// NULL̏ꍇ́Azt@CiRg[plȂǁjł\܂B
		SHDESCRIPTIONID	desc;	// dwDescriptionId: SHDID_FS_FILE, SHDID_FS_DIRECTORY

		const bool IsFile() const	{ return desc.dwDescriptionId == SHDID_FS_FILE; }
	};

	struct Symbol
	{
		UINT	ID;		// ID
		LPTSTR	Name;	// O
		LPTSTR	Short;	// Z
		LPTSTR	Long;	// 
		INT		Image;	// C[WXgł̃CfbNXB-1 ̏ꍇ̓C[WȂB
	};

	enum SuitLevel
	{
		SUIT_NONE	=  0,	// JƂł܂B
		SUIT_LOWEST	=  1,
		SUIT_LOW	= 10,	// 肪ȂJ\܂BFeLXgGfB^oCit@CJB
		SUIT_MIDDLE	= 20,	// sȂJƂł܂BFeLXgGfB^m̊gq̃t@CJB
		SUIT_HIGH	= 30,	// łKĂ܂B
	};

	enum ElementChange
	{
		CHANGE_FACTORY_ADD,		// t@Ngǉ܂
		CHANGE_FACTORY_DELETE,	// t@Ng폜܂
		CHANGE_FACTORY_MOVE,	// t@Ng̕яω܂
		CHANGE_SIDEBAR_ADD,		// TCho[ǉ܂
		CHANGE_SIDEBAR_MOVE,	// TCho[폜܂
		CHANGE_SIDEBAR_DELETE,	// TCho[̕яω܂
		CHANGE_SIDEBAR_ACTIVE,	// ANeBuTCho[ω܂
		CHANGE_PANE_ADD,		// yCǉ܂
		CHANGE_PANE_MOVE,		// yC폜܂
		CHANGE_PANE_DELETE,		// yC̕яω܂
		CHANGE_PANE_ACTIVE,		// ANeBuyCω܂
		CHANGE_VIEW_ADD,		// r[ǉ܂
		CHANGE_VIEW_MOVE,		// r[폜܂
		CHANGE_VIEW_DELETE,		// r[̕яω܂
		CHANGE_VIEW_ACTIVE,		// ANeBur[ω܂
	};

	const MAX_PANE_COUNT = 9;

	enum WindowID
	{
		// Ct[B
		WINDOW_MAINFRAME,
		// t@Ng̐e(CPaneWindow)
		WINDOW_FACTORY,
		// R}ho[(CCommandBarCtrl)
		WINDOW_MENUBAR,
		// c[o[(CToolBarCtrl)
		WINDOW_TOOLBAR,
		// AhXo[(CComboBoxEx)
		WINDOW_ADDRESSBAR,
		// Xe[^Xo[(CStatusBarCtrl)
		WINDOW_STATUSBAR,
		// TCho[(CPaneWindow)
		WINDOW_SIDEBAR,
		// yC̐e(CPaneWindow)
		WINDOW_PANESPLITTER,
		// ANeBuȃyC(CPaneWindow)
		WINDOW_PANE_ACTIVE,
		// ŏ̃yC(CPaneWindow)
		WINDOW_PANE_FIRST,
		// Ō̃yC(CPaneWindow)
		WINDOW_PANE_LAST = WINDOW_PANE_FIRST + MAX_PANE_COUNT,
		// ANeBuȃr[
		WINDOW_VIEW_ACTIVE
	};

	enum ControlType
	{
		// ListView
		CONTROL_LISTVIEW,
		// TreeView : TVS_FULLROWSELECT | TVS_HASLINES | TVS_HASBUTTONS | TVS_SHOWSELALWAYS | TVS_SINGLEEXPAND | TVS_TRACKSELECT | TVS_NOTOOLTIPS;
		CONTROL_TREEVIEW,
	};

	////////////////////////////////////////////////////////////////////////////////
	// VXẽC^tF[X

	[ uuid("53A0ED0A-F6D9-45F9-869F-A8459447B1A7") ]
	__interface ITablet
	{
		// nh擾܂B
		// WINDOW_PANE_* w肵A܂̃yC쐬ĂȂꍇ͎Iɍ쐬܂B
		// @param id	WindowID 񋓎qׂ̂Ă̒lLłB
		HWND GetWindow(WindowID id);

		// q̐擾܂B
		// GetWindow(id).CountElements() ̃V[gJbgłB
		// @param id	WINDOW_FACTORY, WINDOW_SIDEBAR, WINDOW_PANESPLITTER, WINDOW_PANE_* ݂̂LłB
		UINT CountElements(WindowID id);

		// q擾܂B
		// GetWindow(id).GetElement(index) ̃V[gJbgłB
		// @param id	WINDOW_FACTORY, WINDOW_SIDEBAR, WINDOW_PANESPLITTER, WINDOW_PANE_* ݂̂LłB
		// @param index	q̃CfbNXw肵܂B-1 ̏ꍇ́A݃ANeBuȎq擾܂B
		// @result		q̃nhԂ܂BCfbNX͈͊ȌꍇNULLԂ܂B
		HWND GetElement(WindowID id, UINT index);
		
		// r[ړ܂B
		// @param hWnd  ړr[BɂꂩyCɑĂKv܂B
		// @praam pane  ړ̃r[yCCfbNXB-1 w肷ƐVKyCB
		// @param index ړ̃^uCfbNXB-1 w肷ƍłEB
		BOOL MoveElement(HWND hWnd, UINT pane, UINT index);

		// t@Ngɏ]ė^ꂽt@CJ܂B
		// t@CV[gJbg̏ꍇÃV[gJbgwĂJ܂B
		// @param entry   t@CGgB
		// @param pane    ǉ̃yCByCȊOIDnƎs܂B
		// @param documnt 쐬t@Ng̃CfbNXB-1 w肷ƍœKȂ̂܂B
		// @param minSuitLevel ŒKxBȏ̓Kxt@NgȂΎs܂B
		BOOL OpenFile(const FileEntry& entry, WindowID pane = WINDOW_PANE_ACTIVE, UINT document = -1, INT minSuitLevel = SUIT_NONE);

		// [Uݒ肵eRRg[Look&FeelX^C擾܂B
		DWORD GetControlStyle(ControlType type);

		// OfficeXP̃|bvAbvj[\܂B
		UINT TrackPopupMenu(HMENU hMenu, POINT pt, HWND hWnd, UINT uFlags = TPM_LEFTALIGN | TPM_TOPALIGN | TPM_RETURNCMD | TPM_RIGHTBUTTON, LPTPMPARAMS lpParams = NULL);

		// XML 烁j[ǂݍ݂܂B
		HMENU LoadMenu(VARIANT xml);

		// XML ANZ[^ǂݍ݂܂B
		HACCEL LoadAccelerators(VARIANT xml);

		// VXeC[WXgԂ܂B
		HIMAGELIST GetImageList(bool big);

		//
		UINT CountHistory();

		//
		LPCTSTR GetHistory(UINT index);

		// ɃpXǉ܂B
		// ɒǉς݂̕Ɠꍇ͒ǉ܂B
		// VXẽR}hŃt@CJꍇÃpX̓VXeǉ܂B
		// VXeʂɃr[쐬ꍇȂǂ́AvOC疾IɌĂłB
		// @result qXgz񒆂ł̃CfbNXB
		UINT AddHistory(LPCTSTR path);
	};

	////////////////////////////////////////////////////////////////////////////////
	// GNX|[g֐
	//		vOC͂̊֐GNX|[gĂB

	// ܂B
	const LPCSTR EXPORTED_FUNCTION_INITIALIZE = "TabletInitialize";
	typedef BOOL (*TabletInitialize_t)(ITablet* pTablet);

	// ㏈܂B
	const LPCSTR EXPORTED_FUNCTION_TERMINATE= "TabletTerminate";
	typedef void (*TabletTerminate_t)();

	////////////////////////////////////////////////////////////////////////////////
	// 萔

	const LPCTSTR PLUGIN_DIRECTORY	= _T("plugin");
	const LPCTSTR PLUGIN_WILDCARD	= _T("plugin\\*.dll");
}
