// Collection.h
#pragma once

#include <algorithm>
#include <functional>

namespace mew {

/////////////////////////////////////////////////////////////////////////////
// Classes in this file
//
// CStdVector<E, ETratis>	: _ATL_MIN_CRT ̂߂ std::vector gȂꍇ̑փNXB
// CAutoPtrVector<E>		: 

/////////////////////////////////////////////////////////////////////////////

template < typename E, typename ETraits = CElementTraits<E> >
class CStdVector : public CAtlArray<E, ETraits>
{
public:
	typedef       E*	iterator;
	typedef const E*	const_iterator;
	typedef size_t		size_type;
	typedef E			value_type;

public:
	iterator       begin()			{ return GetData(); }
	const_iterator begin() const	{ return GetData(); }
	iterator       end()			{ return GetData()+GetCount(); }
	const_iterator end() const		{ return GetData()+GetCount(); }

	size_type size() const	{ return GetCount(); }
	bool empty() const		{ return IsEmpty(); }
	OUTARGTYPE	front()	{ return GetAt(0); }
	OUTARGTYPE	back()	{ return GetAt(GetCount()-1); }
	void push_back(INARGTYPE item)	{ Add(item); }
	void pop_back()				{ RemoveAt(GetCount()-1); }
	void clear()				{ RemoveAll(); }
	void resize(size_type sz)	{ SetCount(sz); }
	void reserve(size_t size)
	{	// RXgN^Ăł܂̂ŁA͈B
		size_t c = GetCount();
		SetCount(size);
		SetCount(c);
	}
	iterator insert(iterator where, INARGTYPE item)
	{
		size_t at = where-begin();
		InsertAt(at, item);
		return begin()+at;
	}
};

////////////////////////////////////////////////////////////////////////////

template < class E >
class CAutoPtrVector : public CStdVector< ATL::CAutoPtr<E>, ATL::CAutoPtrElementTraits<E> >
{
};

////////////////////////////////////////////////////////////////////////////

/// for_all
template < class Cont, class Pred1 >
Pred1 for_all(Cont& cont, Pred1 pred)
{
	return std::for_each(cont.begin(), cont.end(), pred);
}

/// for_all
template < class Cont, class Pred1 >
Pred1 for_all(const Cont& cont, Pred1 pred)
{
	return std::for_each(cont.begin(), cont.end(), pred);
}

/// erase_it
template < class Cont, class Item >
void erase_it(Cont& cont, const Item& item)
{
	cont.erase(std::remove(cont.begin(), cont.end(), item), cont.end());
}

/// erase_if
template < class Cont, class Pred1 >
void erase_if(Cont& cont, Pred1 pred)
{
	cont.erase(std::remove_if(cont.begin(), cont.end(), pred), cont.end());
}

/// find_if
template < class Cont, class Pred1 >
typename Cont::iterator find_if(Cont& cont, Pred1 pred)
{
	return std::find_if(cont.begin(), cont.end(), pred);
}

/// binary_search
/// std::binary_search()  boollԂȂ̂ɑ΂A͌C^[^Ԃ.
template < class FwdIter, class Type >
FwdIter binary_search(FwdIter _First, FwdIter _Last, const Type& _Val)
{
	FwdIter result = std::lower_bound(_First, _Last, _Val);
	if(result != _Last && *result == _Val)
		return result;
	else
		return _Last;
}

/// binary_search
/// std::binary_search()  boollԂȂ̂ɑ΂A͌C^[^Ԃ.
template < class FwdIter, class Type, class Pred2 >
FwdIter binary_search(FwdIter _First, FwdIter _Last, const Type& _Val, Pred2 _Comp)
{
	FwdIter result = std::lower_bound(_First, _Last, _Val, _Comp);
	if(result != _Last && _Comp(*result, _Val))
		return result;
	else
		return _Last;
}

/// operator delete
struct operator_delete
{
	template < typename T > void operator () (T* ptr) const { delete ptr; }
};

/// obj->method(_1)
template < class Obj, class T, class Result, class Arg >
std::binder1st< std::mem_fun1_t<Result, T, Arg> >
mem_fun(Obj obj, Result (T::*m)(Arg))
{
	return std::bind1st(std::mem_fun1(m), obj);
}

/// _1->method(obj)
template < class T, class Result, class Arg, class Obj >
std::binder2nd< std::mem_fun1_t<Result, T, Arg> >
mem_fun(Result (T::*m)(Arg), Obj obj)
{
	return std::bind2nd(std::mem_fun1(m), obj);
}

/// obj->method(_1)
template < class Obj, class T, class Result, class Arg >
std::binder1st< std::mem_fun1_ref_t<Result, T, Arg> >
mem_fun_ref(Obj obj, Result (T::*m)(Arg))
{
	return std::bind1st(std::mem_fun1_ref(m), obj);
}

/// _1->method(obj)
template < class T, class Result, class Arg, class Obj >
std::binder2nd< std::mem_fun1_ref_t<Result, T, Arg> >
mem_fun_ref(Result (T::*m)(Arg), Obj obj)
{
	return std::bind2nd(std::mem_fun1_ref(m), obj);
}

/////////////////////////////////////////////////////////////////////////////

} // namespace mew
