#ifndef __CUSTOMTABCTRL_H__
#define __CUSTOMTABCTRL_H__

#pragma once

// Feel  Look ɕ悤Ƃ܂A
// r[ɂȂĂ܂B

#ifndef __cplusplus
  #error ATL requires C++ compilation (use a .cpp suffix)
#endif

#ifndef __ATLAPP_H__
  #error CustomTabCtrl.h requires atlapp.h to be included first
#endif

#ifndef __ATLCTRLS_H__
  #error CustomTabCtrl.h requires atlctrls.h to be included first
#endif

#ifndef __ATLGDIX_H__
  #error CustomTabCtrl.h requires atlgdix.h to be included first
#endif

// There are slightly different dependencies under VC 7 (ATL 7) vs. VC 6 (ATL 3)
#if (_ATL_VER >= 0x0700)
	#if !defined(__ATLCOLL_H__)
		#error CustomTabCtrl.h requires atlcoll.h (under VC 7).
	#endif
	#if !defined(__ATLSTR_H__)
		#error CustomTabCtrl.h requires CString. In VC 7, include atlstr.h
	#endif
	#if defined(__ATLMISC_H__) && !defined(_WTL_NO_CSTRING)
		#error In VC 7, please define _WTL_NO_CSTRING if you include atlmisc.h
	#endif
#else
	#if !defined(_WTL_USE_CSTRING)
		#error CustomTabCtrl.h requires CString. In VC 6, be sure to include atlmisc.h.
	#endif
#endif

#if (_WIN32_IE < 0x0400)
  #error CustomTabCtrl.h requires _WIN32_IE >= 0x0400
#endif

// Window styles:
// NOTE: "CTCS" stands for "Custom tab control style"
#define CTCS_SCROLL              0x0001   // TCS_SCROLLOPPOSITE
#define CTCS_BOTTOM              0x0002   // TCS_BOTTOM
//#define CTCS_RIGHT               0x0002   // TCS_RIGHT
#define CTCS_MULTISELECT         0x0004   // TCS_MULTISELECT
#define CTCS_CLOSEBUTTON         0x0008   // TCS_FLATBUTTONS
//#define CTCS_FORCEICONLEFT       0x0010   // TCS_FORCEICONLEFT
//#define CTCS_FORCELABELLEFT      0x0020   // TCS_FORCELABELLEFT
#define CTCS_HOTTRACK            0x0040   // TCS_HOTTRACK
//#define CTCS_VERTICAL            0x0080   // TCS_VERTICAL
//#define CTCS_TABS                0x0000   // TCS_TABS
#define CTCS_FLATEDGE            0x0100   // TCS_BUTTONS
//#define CTCS_SINGLELINE          0x0000   // TCS_SINGLELINE
//#define CTCS_MULTILINE           0x0200   // TCS_MULTILINE
//#define CTCS_RIGHTJUSTIFY        0x0000   // TCS_RIGHTJUSTIFY
//#define CTCS_FIXEDWIDTH          0x0400   // TCS_FIXEDWIDTH
//#define CTCS_RAGGEDRIGHT         0x0800   // TCS_RAGGEDRIGHT
//#define CTCS_FOCUSONBUTTONDOWN   0x1000   // TCS_FOCUSONBUTTONDOWN
#define CTCS_BOLDSELECTEDTAB     0x2000   // TCS_OWNERDRAWFIXED
#define CTCS_TOOLTIPS            0x4000   // TCS_TOOLTIPS
//#define CTCS_FOCUSNEVER          0x8000   // TCS_FOCUSNEVER

// Notifications:

#define CTCN_FIRST              (0U-550U)           // TCN_FIRST
#define CTCN_LAST               (0U-580U)           // TCN_LAST

#define CTCN_SELCHANGE          (TCN_FIRST - 1)     // TCN_SELCHANGE
#define CTCN_SELCHANGING        (TCN_FIRST - 2)     // TCN_SELCHANGING
//#define CTCN_GETOBJECT          (TCN_FIRST - 3)     // TCN_GETOBJECT
//#define CTCN_FOCUSCHANGE        (TCN_FIRST - 4)     // TCN_FOCUSCHANGE
//#define CTCN_INITIALIZE         (TCN_FIRST - 10)    // obsolete for now
#define CTCN_MOUSE        (TCN_FIRST - 10)	// NM_xCLICK Ȃǂ𑗂ɁANMCTCMOUSE 𑗂܂B
#define CTCN_INSERTITEM         (TCN_FIRST - 11)
#define CTCN_DELETEITEM         (TCN_FIRST - 12)
#define CTCN_MOVEITEM           (TCN_FIRST - 13)
#define CTCN_SWAPITEMPOSITIONS  (TCN_FIRST - 14)
#define CTCN_CLOSE              (TCN_FIRST - 15)

// Hit Test codes
#define CTCHT_NOWHERE            0x0001             // TCHT_NOWHERE
#define CTCHT_ONITEMICON         0x0002             // TCHT_ONITEMICON
#define CTCHT_ONITEMLABEL        0x0004             // TCHT_ONITEMLABEL
#define CTCHT_ONITEM             (CTCHT_ONITEMICON | CTCHT_ONITEMLABEL)
#define CTCHT_ONCLOSEBTN         0x0010
#define CTCHT_ONSCROLLRIGHTBTN   0x0020
#define CTCHT_ONSCROLLLEFTBTN    0x0040

// Number of milliseconds for scroll repeat
#define CTCSR_NONE                0
#define CTCSR_SLOW                100
#define CTCSR_NORMAL              25
#define CTCSR_FAST                10

typedef struct tagCTCHITTESTINFO
{
	POINT pt;        // Client Coordinates of point to test
	UINT flags;
} CTCHITTESTINFO, *LPCTCHITTESTINFO;

// Structures
typedef struct tagNMCTCITEM
{
	NMHDR   hdr;
	int     iItem;  // Item Index
	POINT   pt;     // Client Coordinates
} NMCTCITEM, *LPNMCTCITEM;

typedef struct tagNMCTC2ITEMS
{
	NMHDR   hdr;
	int     iItem1;  // First Item Index
	int     iItem2;  // Second Item Index
	POINT   pt;      // Client Coordinates
} NMCTC2ITEMS, *LPNMCTC2ITEMS;

struct NMCTCMOUSE
{
	NMHDR   hdr;
	int     iItem;  // Item Index
	UINT    uMsg;	// WM_xBUTTONDOWN/UP/DBLCLK
	CTCHITTESTINFO hit;     // Client Coordinates
};

typedef struct tagNMCTCCUSTOMDRAW
{
	NMCUSTOMDRAW nmcd;
	HFONT hFontInactive;
	HFONT hFontSelected;
	HBRUSH hBrushBackground;
	COLORREF clrTextInactive;
	COLORREF clrTextSelected;
	COLORREF clrSelectedTab;
	COLORREF clrBtnFace;
	COLORREF clrBtnShadow;
	COLORREF clrBtnHighlight;
	COLORREF clrBtnText;
	COLORREF clrHighlight;
	COLORREF clrHighlightHotTrack;
} NMCTCCUSTOMDRAW, FAR * LPNMCTCCUSTOMDRAW;

// Flags, internal state, etc.
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +-------+-------+-------+-------+---+-----------+---------------+
//  |  FUT  |  MO   |  MD   |  HT   |SR |    SD     |     FLAGS     |
//  +-------+-------+-------+-------+---+-----------+---------------+
//
//  FLAGS - boolean flags
//  SD - Scroll delta.  The number of pixels to move in a single scroll.
//       Valid values are 0-63 (the value is bit shifted to/from position).
//  SR - Scroll repeat speed.  Valid values are no-repeat,
//       slow repeat, normal repeat and fast repeat
//  HT - Current hot tracked item (if its a tab, then m_iHotItem is the hot tab item) 
//  MD - Item under mouse when mouse button down message was sent
//       but before mouse button up message is sent
//  MO - Item current under mouse cursor
//  FUT - Not used at this time, but reserved for the future.

enum CTCS_STATESBITS
{
	// Flags
	// bits                   = 0x000000ff
	ectcMouseInWindow         = 0x00000001,
	ectcOverflowLeft          = 0x00000002,
	ectcOverflowRight         = 0x00000004,
	//ectcOverflowBottom        = 0x00000002,  // alias for vertical mode
	//ectcOverflowTop           = 0x00000004,  // alias for vertical mode
	ectcEnableRedraw          = 0x00000008,
	//ectcFlag10                = 0x00000010,
	//ectcFlag20                = 0x00000020,
	//ectcFlag40                = 0x00000040,
	//ectcFlag80                = 0x00000080,

	// Scroll
	// bits                   = 0x0000ff00
	ectcScrollDeltaMask       = 0x00003f00,    //0011 1111
	ectcScrollDeltaShift      = 8,

	// We have to publicly expose these:
	ectcScrollRepeat          = 0x0000c000,    //1100 0000
	//ectcScrollRepeat_None     = 0x00000000,
	//ectcScrollRepeat_Slow     = 0x00004000,    //0100 0000
	//ectcScrollRepeat_Normal   = 0x00008000,    //1000 0000
	//ectcScrollRepeat_Fast     = 0x0000c000,    //1100 0000

	// Hot Tracking
	// bits                   = 0x000f0000
	ectcHotTrack              = 0x000f0000,
	ectcHotTrack_CloseButton  = 0x00010000,
	ectcHotTrack_ScrollRight  = 0x00020000,
	ectcHotTrack_ScrollLeft   = 0x00030000,
	ectcHotTrack_TabItem      = 0x00040000,

	// Mouse Down
	// bits                   = 0x00f00000
	ectcMouseDown             = 0x00f00000,
	ectcMouseDown_CloseButton = 0x00100000,
	ectcMouseDown_ScrollRight = 0x00200000,
	ectcMouseDown_ScrollLeft  = 0x00300000,
	ectcMouseDown_TabItem     = 0x00400000,

	// Mouse Over
	// bits                   = 0x0f000000
	ectcMouseOver             = 0x0f000000,
	ectcMouseOver_CloseButton = 0x01000000,
	ectcMouseOver_ScrollRight = 0x02000000,
	ectcMouseOver_ScrollLeft  = 0x03000000,
	ectcMouseOver_TabItem     = 0x04000000,
};

// Tab Item classes

class CCustomTabItem
{
// Member variables
protected:
	CRect m_rcItem;
	CString m_sText;
	CString m_sToolTip;

// Constructors/Destructors
public:
	CCustomTabItem()
	{
		m_rcItem.SetRectEmpty();
	}

// Accessors
public:
	const CRect& GetRect() const	{ return m_rcItem; }
	void    SetRect(RECT rcItem)	{ m_rcItem = rcItem; }
	LPCTSTR GetText() const			{ return m_sText; }
	void    SetText(LPCTSTR text)	{ m_sText = text; }
	LPCTSTR GetToolTip() const		{ return m_sToolTip; }
	void    SetToolTip(LPCTSTR text){ m_sToolTip = text; }

// Methods:
public:
	bool UsingText() const		{ return (m_sText.GetLength() > 0); }
	bool UsingToolTip() const	{ return (m_sToolTip.GetLength() > 0); }
};

/////////////////////////////////////////////////////////////////////////////
//
// CTabCtrlFeelImpl<T, TItem>
//
/////////////////////////////////////////////////////////////////////////////

template < class T, class TItem >
class ATL_NO_VTABLE CTabCtrlFeelImpl
{
public:
	// Expose the item type (that's a template parameter to this base class)
	typedef TItem ItemType;

// Member variables
private:
	int m_iCurSel;
	int m_iHotItem;
	CAtlArray< TItem* > m_Items;

protected:
	DWORD m_dwTabCtrlState;

protected:
	CTabCtrlFeelImpl() :
		m_dwTabCtrlState(0),
		m_iCurSel(-1),
		m_iHotItem(-1)
	{}

// Overridables
public:
	TItem* AllocItem()
	{
		return new TItem();
	}

	void FreeItem(TItem* pOldItem)
	{
		delete pOldItem;
	}

// Operation
public:
	int GetCurSel() const
	{
#ifdef _DEBUG
		if(static_cast<const T*>(this)->GetStyle() & CTCS_MULTISELECT)
			ATLTRACE("CTCS_MULTISELECT GetCurSel()Ă΂܂B\n");
#endif
		return m_iCurSel;
	}

	bool GetSel(int index) const
	{
		return m_iCurSel == index;
	}

	int GetItemCount() const
	{
		return (int)m_Items.GetCount();
	}
	int GetSelectedCount() const
	{
		return m_iCurSel >= ? 1 : 0;
	}
	// usage:
	// int selected = -1;
	// while(GetNextSelectedItem(&selected)) { ... }
	bool GetNextSelectedItem(int* iter) const
	{
		*iter = (*iter < m_iCurSel) ? m_iCurSel : -1;
		return *iter >= 0;
	}
	int GetHotItem() const
	{
		return m_iHotItem;
	}

	TItem* GetItem(int nItem) const
	{
		if((UINT)nItem >= (UINT)GetItemCount())
		{
			return NULL;
		}
		return m_Items[nItem];
	}

protected:
	void InternalSetCurSel(int index)
	{
		m_iCurSel = index;
	}
	void IntenalSetHotItem(int index)
	{
		m_iHotItem = index;
	}
	void InternalInsertItem(int index, TItem* pItem)
	{
		m_Items.InsertAt((size_t)index, pItem);
	}
	void InternalRemoveItem(int index)
	{
		m_Items.RemoveAt(index);
	}

// Message
	BEGIN_MSG_MAP(CTabCtrlFeelImpl)
		MESSAGE_HANDLER(WM_GETFONT, OnGetFont)
		MESSAGE_HANDLER(WM_SETFONT, OnSetFont)
		CHAIN_MSG_MAP(__super)
	END_MSG_MAP()

	LRESULT OnGetFont(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		// DDB: 2002/04/22
		// The code was doing GetFont and SetFont, but wasn't actually
		//  properly dealing with implementing it if the window
		//  was not a subclassed static control.
		return (LRESULT)(HFONT)m_font;
	}

	LRESULT OnSetFont(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
	{
		// DDB: 2002/04/22
		// The code was doing GetFont and SetFont, but wasn't actually
		//  properly dealing with implementing it if the window
		//  was not a subclassed static control.
		//
		// Also, we're managing the lifetime of our font
		//  (i.e., we're going to DeleteObject it in our destructor),
		//  so if someone calls SetFont, keep a copy of the
		//  font instead of just "pointing" to it
		LOGFONT lfCopy = {0};
		::GetObject((HFONT)wParam, sizeof(LOGFONT), &lfCopy);

		if(!m_font.IsNull()) m_font.DeleteObject();

		m_font.CreateFontIndirect(&lfCopy);

		if(LOWORD(lParam))
		{
			this->Invalidate();
		}

		return 0;
	}
};

/////////////////////////////////////////////////////////////////////////////
//
// CTabCtrlFeelLook<T>
//
/////////////////////////////////////////////////////////////////////////////

template < class T, class TItem >
class ATL_NO_VTABLE CTabCtrlLookImpl : public COffscreenDrawRect<T>
{
public:

protected:
	CFont m_font;
	CFont m_fontSel;
	CRect m_rcTabItemArea;
	CRect m_rcScrollLeft;
	CRect m_rcScrollRight;
	CRect m_rcCloseButton;

protected:
	CTabCtrlLookImpl()
	{
		::SetRectEmpty(&m_rcTabItemArea);
		::SetRectEmpty(&m_rcCloseButton);
		::SetRectEmpty(&m_rcScrollLeft);
		::SetRectEmpty(&m_rcScrollRight);
	}

public:
	const CRect& GetTabAreaRect() const { return m_rcTabItemArea; }
	const CRect& GetScrollLeftRect()  const { return m_rcScrollLeft;  }
	const CRect& GetScrollRightRect() const { return m_rcScrollRight; }
	const CRect& GetCloseButtonRect() const { return m_rcCloseButton; }

	int HitTest(LPCTCHITTESTINFO pHitTestInfo) const
	{
		ATLASSERT(!::IsBadWritePtr(pHitTestInfo,sizeof(CTCHITTESTINFO)));
		const T* pT = static_cast<const T*>(this);
		pHitTestInfo->flags = CTCHT_NOWHERE;
		if(::PtInRect(&m_rcTabItemArea, pHitTestInfo->pt))
		{
			// TODO: Do a smarter search.  Currently,
			//  the tabs are always going to be left to right.
			//  Use this knowledge to do a better spacial search.

			RECT rcItemDP;
			size_t nCount = pT->GetItemCount();
			for( size_t i=0; i<nCount; ++i )
			{
				// NOTE: GetItemRect accounts for any scroll
				pT->GetItemRect(i, &rcItemDP);

				if( ::PtInRect(&rcItemDP, pHitTestInfo->pt) )
				{
					// TODO: check for ONITEMLABEL, ONITEMICON
					pHitTestInfo->flags = CTCHT_ONITEM;
					return i;
				}
			}
		}
		else
		{
			if(::PtInRect(&m_rcCloseButton, pHitTestInfo->pt))
			{
				pHitTestInfo->flags = CTCHT_ONCLOSEBTN;
			}
			else if(::PtInRect(&m_rcScrollRight, pHitTestInfo->pt))
			{
				pHitTestInfo->flags = CTCHT_ONSCROLLRIGHTBTN;
			}
			else if(::PtInRect(&m_rcScrollLeft, pHitTestInfo->pt))
			{
				pHitTestInfo->flags = CTCHT_ONSCROLLLEFTBTN;
			}
		}
		return -1;
	}

	void CalcComponentSize(const CRect& rcClient)
	{
		m_rcTabItemArea = rcClient;
	}

	void InitializeDrawStruct(LPNMCTCCUSTOMDRAW lpNMCustomDraw)
	{
		lpNMCustomDraw->hFontInactive = m_font;
		lpNMCustomDraw->hFontSelected = m_fontSel;
		lpNMCustomDraw->hBrushBackground = ::GetSysColorBrush(COLOR_BTNFACE);
		lpNMCustomDraw->clrTextSelected = ::GetSysColor(COLOR_BTNTEXT);
		lpNMCustomDraw->clrTextInactive = ::GetSysColor(COLOR_BTNTEXT);
		lpNMCustomDraw->clrSelectedTab = ::GetSysColor(COLOR_BTNFACE);
		lpNMCustomDraw->clrBtnFace = ::GetSysColor(COLOR_BTNFACE);
		lpNMCustomDraw->clrBtnShadow = ::GetSysColor(COLOR_BTNSHADOW);
		lpNMCustomDraw->clrBtnHighlight = ::GetSysColor(COLOR_BTNHIGHLIGHT);
		lpNMCustomDraw->clrBtnText = ::GetSysColor(COLOR_BTNTEXT);
		lpNMCustomDraw->clrHighlight = ::GetSysColor(COLOR_HIGHLIGHT);
#if WINVER >= 0x0500 || _WIN32_WINNT >= 0x0500
		lpNMCustomDraw->clrHighlightHotTrack = ::GetSysColor(COLOR_HOTLIGHT);
#else
		lpNMCustomDraw->clrHighlightHotTrack = ::GetSysColor(COLOR_HIGHLIGHT);
#endif
	}

	void ProcessItem(LRESULT lResCustom, LPNMCTCCUSTOMDRAW lpNMCustomDraw, DWORD dwStateBits)
	{
		T* pT = static_cast<T*>(this);
		LRESULT lResItem = CDRF_DODEFAULT;
		if( CDRF_NOTIFYITEMDRAW == (lResCustom & CDRF_NOTIFYITEMDRAW) )
		{
			lpNMCustomDraw->nmcd.dwDrawStage = CDDS_ITEMPREPAINT;
			lResItem = ::SendMessage(pT->GetParent(), WM_NOTIFY, lpNMCustomDraw->nmcd.hdr.idFrom, (LPARAM)lpNMCustomDraw);
		}
		if( CDRF_SKIPDEFAULT != (lResCustom & CDRF_SKIPDEFAULT) )
		{
			// Do default item-drawing
			T* pT = static_cast<T*>(this);
			pT->DoItemPaint(lpNMCustomDraw, dwStateBits);
		}
		if( CDRF_NOTIFYITEMDRAW == (lResCustom & CDRF_NOTIFYITEMDRAW) &&
			CDRF_NOTIFYPOSTPAINT == (lResItem & CDRF_NOTIFYPOSTPAINT))
		{
			lpNMCustomDraw->nmcd.dwDrawStage = CDDS_ITEMPOSTPAINT;
			::SendMessage(pT->GetParent(), WM_NOTIFY, lpNMCustomDraw->nmcd.hdr.idFrom, (LPARAM)lpNMCustomDraw);
		}
	}

	void DoPrePaint(RECT rcClient, LPNMCTCCUSTOMDRAW lpNMCustomDraw, DWORD dwStateBits)
	{
		// "Erase Background"
		// NOTE: Your derived class might be able to do a
		//  better job of erasing only the necessary area
		//  (using the clip box, etc.)
		CDCHandle dc(lpNMCustomDraw->nmcd.hdc);

		HBRUSH hOldBrush = dc.SelectBrush(lpNMCustomDraw->hBrushBackground);
		dc.PatBlt(rcClient.left, rcClient.top, rcClient.right-rcClient.left, rcClient.bottom-rcClient.top, PATCOPY);
		dc.SelectBrush(hOldBrush);

		dc.SetTextColor(lpNMCustomDraw->clrTextInactive);
		dc.SetBkMode(TRANSPARENT);
	}

	void DoItemPaint(LPNMCTCCUSTOMDRAW /*lpNMCustomDraw*/, DWORD dwStateBits)
	{
	}

	void DoPostPaint(RECT /*rcClient*/, LPNMCTCCUSTOMDRAW /*lpNMCustomDraw*/, DWORD dwStateBits)
	{
		// In your derived verion, paint the scroll buttons if CTCS_SCROLL
		// is set and the close button if CTCS_CLOSEBUTTON is set
		// (if you want to support these)
	}

	void UpdateLayout_Default(RECT rcTabItemArea)
	{
		UpdateLayout_ScrollToFit(rcTabItemArea);
	}

	void UpdateLayout_ScrollToFit(RECT rcTabItemArea)
	{
		CClientDC dc(m_hWnd);
		HFONT hOldFont = dc.SelectFont(this->GetFont());    

		int height = rcTabItemArea.bottom-rcTabItemArea.top;

		// Reposition tabs
		size_t nCount = GetItemCount();
		int xpos = m_settings.iIndent;
		for( size_t i=0; i<nCount; ++i )
		{
			TItem* pItem = m_Items[i];
			RECT rc = {xpos, 0, xpos, height};
			if( pItem->UsingText() )
			{
				RECT rcText = { 0 };
				dc.DrawText(pItem->GetText(), -1, &rcText, DT_SINGLELINE | DT_CALCRECT);
				rc.right += (rcText.right-rcText.left) + (m_settings.iPadding*2);
			}
			pItem->SetRect(rc);
			xpos += (rc.right-rc.left) + m_settings.iMargin;
		}
		if( GetCurSel() >=0 && (size_t)GetCurSel() < nCount )
		{
			m_Items[GetCurSel()]->InflateRect(m_settings.iSelMargin, 0);
		}

		dc.SelectFont(hOldFont);
	}
};

/////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////

typedef CWinTraits<WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS | CTCS_TOOLTIPS, 0> CCustomTabCtrlWinTraits;

template <
	class T,
	class TItem = CCustomTabItem,
	class TBase = CWindow,
	class TWinTraits = CCustomTabCtrlWinTraits,
	template < class, class > class TLook = CTabCtrlLookImpl,
	template < class, class > class TFeel = CTabCtrlFeelImpl>
class ATL_NO_VTABLE CCustomTabCtrl : 
	public CWindowImpl< T, TBase, TWinTraits >,
	public TLook<T, TItem>,
	public TFeel<T, TItem>
{
private:
	typedef CWindowImpl< T, TBase, TWinTraits > baseClass;
	typedef TLook<T, TItem>	LookType;
	typedef TFeel<T, TItem>	FeelType;
public:
	typedef typename FeelType::ItemType	ItemType;

// Member variables
private:
	UINT m_idDlgCtrl;

protected:
	CToolTipCtrl m_tooltip;
	int m_iScrollOffset;

	enum ButtonToolTipIDs
	{
		ectcToolTip_Close         = 0xFFFFFFF0,
		ectcToolTip_ScrollRight   = 0xFFFFFFF1,
		ectcToolTip_ScrollLeft    = 0xFFFFFFF2,
	};

	enum TimerIDs
	{
		ectcTimer_ScrollLeft      = 0x00000010,
		ectcTimer_ScrollRight     = 0x00000020,
	};

// Public enumerations
public:
	enum ScrollRepeat
	{
		ectcScrollRepeat_None     = 0x00000000,
		ectcScrollRepeat_Slow     = 0x00004000,
		ectcScrollRepeat_Normal   = 0x00008000,
		ectcScrollRepeat_Fast     = 0x0000c000,
	};

// Constructors
public:
	CCustomTabCtrl() :
		m_idDlgCtrl(0),
		m_iScrollOffset(0)
	{
		m_dwTabCtrlState |=  ((40 << ectcScrollDeltaShift) & ectcScrollDeltaMask);
		m_dwTabCtrlState |=  ectcScrollRepeat_Normal;

		m_dwTabCtrlState |= ectcEnableRedraw;
	}

// Implementation
protected:

	void InitializeTooltips(void)
	{
		// Be sure InitCommonControlsEx is called before this,
		//  with one of the flags that includes the tooltip control
		m_tooltip.Create(m_hWnd, NULL, NULL, WS_POPUP | TTS_NOPREFIX | TTS_ALWAYSTIP /* | TTS_BALLOON */, WS_EX_TOOLWINDOW);
		if(m_tooltip.IsWindow())
		{
			m_tooltip.SetWindowPos(HWND_TOPMOST, 0, 0, 0, 0,
				 SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);

			m_tooltip.SetDelayTime(TTDT_INITIAL, ::GetDoubleClickTime());
			m_tooltip.SetDelayTime(TTDT_AUTOPOP, ::GetDoubleClickTime() * 20);
			m_tooltip.SetDelayTime(TTDT_RESHOW, ::GetDoubleClickTime() / 5);
		}
	}

	void ActivateTooltips(BOOL bActivate = TRUE)
	{
		ATLASSERT(m_tooltip.IsWindow());
		if(m_tooltip.IsWindow())
		{
			m_tooltip.Activate(bActivate);
		}
	}

	void ClearCurrentHotTracking(bool bRedrawEffectedArea = true)
	{
		switch(m_dwTabCtrlState & ectcHotTrack)
		{
		case ectcHotTrack_CloseButton:
			m_dwTabCtrlState &= ~ectcHotTrack;
			if(bRedrawEffectedArea)
			{
				this->InvalidateRect(GetCloseButtonRect());
			}
			break;
		case ectcHotTrack_ScrollRight:
			m_dwTabCtrlState &= ~ectcHotTrack;
			if(bRedrawEffectedArea)
			{
				this->InvalidateRect(GetScrollRightRect());
			}
			break;
		case ectcHotTrack_ScrollLeft:
			m_dwTabCtrlState &= ~ectcHotTrack;
			if(bRedrawEffectedArea)
			{
				this->InvalidateRect(GetScrollLeftRect());
			}
			break;
		case ectcHotTrack_TabItem:
			m_dwTabCtrlState &= ~ectcHotTrack;
			IntenalSetHotItem(-1);

			if(bRedrawEffectedArea)
			{
				// In case the derived class actually changes the width
				//  of a hot tracked tab, invalidate the whole tab window
				this->Invalidate();
			}
			break;
		default:
			m_dwTabCtrlState &= ~ectcHotTrack;
			IntenalSetHotItem(-1);
			if(bRedrawEffectedArea)
			{
				this->Invalidate();
			}
			break;
		}
	}

	void ClearCurrentMouseDownTracking(bool bRedrawEffectedArea = true)
	{
		switch(m_dwTabCtrlState & ectcMouseDown)
		{
		case ectcMouseDown_CloseButton:
			m_dwTabCtrlState &= ~ectcMouseDown;
			if(bRedrawEffectedArea)
			{
				this->InvalidateRect(GetCloseButtonRect());
			}
			break;
		case ectcMouseDown_ScrollRight:
			m_dwTabCtrlState &= ~ectcMouseDown;
			if(bRedrawEffectedArea)
			{
				this->InvalidateRect(GetScrollRightRect());
			}
			break;
		case ectcMouseDown_ScrollLeft:
			m_dwTabCtrlState &= ~ectcMouseDown;
			if(bRedrawEffectedArea)
			{
				this->InvalidateRect(GetScrollLeftRect());
			}
			break;
		case ectcMouseDown_TabItem:
			m_dwTabCtrlState &= ~ectcMouseDown;

			if(bRedrawEffectedArea)
			{
				// In case the derived class actually changes the width
				//  of a hot tracked tab, invalidate the whole tab window
				this->Invalidate();

				//if(m_iActionItem >= 0 && m_iActionItem < m_Items.GetCount())
				//{
				//	RECT rcItemDP;
				//	this->GetItemRect(m_iActionItem, &rcItemDP);
				//	this->InvalidateRect(rcItemDP);
				//}
			}
			break;
		default:
			m_dwTabCtrlState &= ~ectcMouseDown;
			if(bRedrawEffectedArea)
			{
				this->Invalidate();
			}
			break;
		}
	}

	void ClearCurrentMouseOverTracking(bool bRedrawEffectedArea = true)
	{
		switch(m_dwTabCtrlState & ectcMouseOver)
		{
		case ectcMouseOver_CloseButton:
			m_dwTabCtrlState &= ~ectcMouseOver;
			if(bRedrawEffectedArea)
			{
				this->InvalidateRect(GetCloseButtonRect());
			}
			break;
		case ectcMouseOver_ScrollRight:
			m_dwTabCtrlState &= ~ectcMouseOver;
			if(bRedrawEffectedArea)
			{
				this->InvalidateRect(GetScrollRightRect());
			}
			break;
		case ectcMouseOver_ScrollLeft:
			m_dwTabCtrlState &= ~ectcMouseOver;
			if(bRedrawEffectedArea)
			{
				this->InvalidateRect(GetScrollLeftRect());
			}
			break;
		case ectcMouseOver_TabItem:
			m_dwTabCtrlState &= ~ectcMouseOver;

			if(bRedrawEffectedArea)
			{
				// In case the derived class actually changes the width
				//  of a hot tracked tab, invalidate the whole tab window
				this->Invalidate();

				//if(m_iActionItem >= 0 && m_iActionItem < m_Items.GetCount())
				//{
				//	RECT rcItemDP;
				//	this->GetItemRect(m_iActionItem, &rcItemDP);
				//	this->InvalidateRect(rcItemDP);
				//}
			}
			break;
		default:
			m_dwTabCtrlState &= ~ectcMouseOver;
			if(bRedrawEffectedArea)
			{
				this->Invalidate();
			}
			break;
		}
	}

// Message Handling
public:
	// Your derived class should use DECLARE_WND_CLASS or DECLARE_WND_SUPERCLASS, etc.
	//DECLARE_WND_CLASS(_T("WTL_CustomTabCtrl"))

	BEGIN_MSG_MAP(CCustomTabCtrl)
		CHAIN_MSG_MAP(LookType)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		MESSAGE_HANDLER(WM_SIZE, OnSize)
		MESSAGE_RANGE_HANDLER(WM_MOUSEFIRST, WM_MOUSELAST, OnMouseMessage)
		MESSAGE_HANDLER(WM_MOUSEMOVE, OnMouseMove)
		MESSAGE_HANDLER(WM_MOUSELEAVE, OnMouseLeave)
		MESSAGE_HANDLER(WM_CAPTURECHANGED, OnCaptureChanged)
		MESSAGE_HANDLER(WM_LBUTTONDOWN		, OnLButtonDown)
		MESSAGE_HANDLER(WM_LBUTTONUP		, OnLButtonUp)
		MESSAGE_HANDLER(WM_LBUTTONDBLCLK	, OnLButtonDoubleClick)
		MESSAGE_HANDLER(WM_RBUTTONDOWN		, OnRButtonDown)
		MESSAGE_HANDLER(WM_RBUTTONUP		, OnRButtonUp)
		MESSAGE_HANDLER(WM_RBUTTONDBLCLK	, OnRButtonDoubleClick)
		MESSAGE_HANDLER(WM_MBUTTONDOWN		, OnMButtonMessage)
		MESSAGE_HANDLER(WM_MBUTTONUP		, OnMButtonMessage)
		MESSAGE_HANDLER(WM_MBUTTONDBLCLK	, OnMButtonMessage)
		MESSAGE_HANDLER(WM_SETTINGCHANGE, OnSettingChange)
		MESSAGE_HANDLER(WM_GETDLGCODE, OnGetDlgCode)
//		MESSAGE_HANDLER(WM_KEYDOWN, OnKeyDown)
		MESSAGE_HANDLER(WM_STYLECHANGED, OnStyleChanged)
		MESSAGE_HANDLER(WM_TIMER, OnTimer)
		MESSAGE_HANDLER(WM_SETREDRAW, OnSetRedraw)
		NOTIFY_CODE_HANDLER(TTN_GETDISPINFO, OnGetToolTipInfo)
	END_MSG_MAP()

	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		LRESULT lRes = DefWindowProc();
		ATLASSERT(::IsWindow(m_hWnd));

		m_idDlgCtrl = GetDlgCtrlID();

		this->SendMessage(WM_SETTINGCHANGE, 0, 0);

		this->InitializeTooltips();

		// NOTE: you can change the style at any time
		//  for a number of the cool tab control styles
		//  (tool tips, close button, scroll buttons, etc.)
		DWORD dwStyle = this->GetStyle();

		this->ActivateTooltips(CTCS_TOOLTIPS == (dwStyle & CTCS_TOOLTIPS));

		if(CTCS_SCROLL == (dwStyle & CTCS_SCROLL))
		{
			if(m_tooltip.IsWindow())
			{
				m_tooltip.AddTool(m_hWnd, _T("Scroll Right"), &rcDefault, ectcToolTip_ScrollRight);
				m_tooltip.AddTool(m_hWnd, _T("Scroll Left"), &rcDefault, ectcToolTip_ScrollLeft);
			}
		}

		if(CTCS_CLOSEBUTTON == (dwStyle & CTCS_CLOSEBUTTON))
		{
			if(m_tooltip.IsWindow())
			{
				m_tooltip.AddTool(m_hWnd, _T("Close"), &rcDefault, ectcToolTip_Close);
			}
		}
		return lRes;
	}

	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
	{
		DWORD dwStyle = this->GetStyle();

		if(m_tooltip.IsWindow())
		{
			if(CTCS_SCROLL == (dwStyle & CTCS_SCROLL))
			{
				m_tooltip.DelTool(m_hWnd, ectcToolTip_ScrollRight);
				m_tooltip.DelTool(m_hWnd, ectcToolTip_ScrollLeft);
			}

			if(CTCS_CLOSEBUTTON == (dwStyle & CTCS_CLOSEBUTTON))
			{
				m_tooltip.DelTool(m_hWnd, ectcToolTip_Close);
			}
		}

		DeleteAllItems();

		bHandled = FALSE;
		return 0;
	}

	LRESULT OnSize(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
	{
		T* pT = static_cast<T*>(this);
		pT->UpdateLayout();
		this->Invalidate();
		bHandled = FALSE;
		return 0;
	}

	LRESULT OnSettingChange(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		T* pT = static_cast<T*>(this);
		pT->UpdateLayout();
		this->Invalidate();
		return 0;
	}

	LRESULT OnGetDlgCode(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
	{
		return DefWindowProc(uMsg, wParam, lParam) | DLGC_WANTARROWS;
	}

	LRESULT OnMouseMessage(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		bHandled = FALSE;
		if(m_tooltip.IsWindow())
		{
			MSG msg = { m_hWnd, uMsg, wParam, lParam };
			m_tooltip.RelayEvent(&msg);
		}
		return 1;
	}

	LRESULT OnMouseMove(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		bHandled = FALSE;

		DWORD dwStyle = this->GetStyle();

		T* pT = static_cast<T*>(this);
		if(ectcMouseInWindow != (m_dwTabCtrlState & ectcMouseInWindow))
		{
			TRACKMOUSEEVENT tme = { 0 };
			tme.cbSize = sizeof(tme);
			tme.dwFlags = TME_LEAVE;
			tme.hwndTrack = m_hWnd;
			if( _TrackMouseEvent(&tme) )
			{
				m_dwTabCtrlState |= ectcMouseInWindow;

				pT->UpdateLayout();
				this->Invalidate();

				// "OnMouseEnter"
				//...
			}
		}

		if(ectcMouseInWindow == (m_dwTabCtrlState & ectcMouseInWindow))
		{
			// hit test
			CTCHITTESTINFO hit = { GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam) };
			int nIndex = HitTest(&hit);

			if(hit.flags == CTCHT_ONCLOSEBTN)
			{
				if( ectcMouseOver_CloseButton != (m_dwTabCtrlState & ectcMouseOver))
				{
					ClearCurrentMouseOverTracking(true);
					m_dwTabCtrlState |= ectcMouseOver_CloseButton;

					if(ectcMouseDown_CloseButton == (m_dwTabCtrlState & ectcMouseDown))
					{
						this->InvalidateRect(GetCloseButtonRect());
					}
				}
				else if( 0 == (m_dwTabCtrlState & ectcMouseDown) &&
					ectcHotTrack_CloseButton != (m_dwTabCtrlState & ectcHotTrack))
				{
					ClearCurrentHotTracking(true);
					m_dwTabCtrlState |= ectcHotTrack_CloseButton;
					this->InvalidateRect(GetCloseButtonRect());
				}
			}
			else
			{
				if(ectcMouseOver_CloseButton == (m_dwTabCtrlState & ectcMouseOver))
				{
					ClearCurrentMouseOverTracking(true);
				}
				if(ectcHotTrack_CloseButton == (m_dwTabCtrlState & ectcHotTrack))
				{
					ClearCurrentHotTracking(true);
				}
			}

			if(hit.flags == CTCHT_ONSCROLLRIGHTBTN)
			{
				if( ectcMouseOver_ScrollRight != (m_dwTabCtrlState & ectcMouseOver))
				{
					ClearCurrentMouseOverTracking(true);
					m_dwTabCtrlState |= ectcMouseOver_ScrollRight;

					if(ectcMouseDown_ScrollRight == (m_dwTabCtrlState & ectcMouseDown))
					{
						this->InvalidateRect(GetScrollRightRect());
					}
				}
				else if(0 == (m_dwTabCtrlState & ectcMouseDown) &&
					ectcHotTrack_ScrollRight != (m_dwTabCtrlState & ectcHotTrack))
				{
					ClearCurrentHotTracking(true);
					m_dwTabCtrlState |= ectcHotTrack_ScrollRight;
					this->InvalidateRect(GetScrollRightRect());
				}
			}
			else
			{
				if(ectcMouseOver_ScrollRight == (m_dwTabCtrlState & ectcMouseOver))
				{
					ClearCurrentMouseOverTracking(true);
				}
				if(ectcHotTrack_ScrollRight == (m_dwTabCtrlState & ectcHotTrack))
				{
					ClearCurrentHotTracking(true);
				}
			}

			if(hit.flags == CTCHT_ONSCROLLLEFTBTN)
			{
				if( ectcMouseOver_ScrollLeft != (m_dwTabCtrlState & ectcMouseOver))
				{
					ClearCurrentMouseOverTracking(true);
					m_dwTabCtrlState |= ectcMouseOver_ScrollLeft;

					if(ectcMouseDown_ScrollLeft == (m_dwTabCtrlState & ectcMouseDown))
					{
						this->InvalidateRect(GetScrollLeftRect());
					}
				}
				else if(0 == (m_dwTabCtrlState & ectcMouseDown) &&
					ectcHotTrack_ScrollLeft != (m_dwTabCtrlState & ectcHotTrack))
				{
					ClearCurrentHotTracking(true);
					m_dwTabCtrlState |= ectcHotTrack_ScrollLeft;
					this->InvalidateRect(GetScrollLeftRect());
				}
			}
			else
			{
				if(ectcMouseOver_ScrollLeft == (m_dwTabCtrlState & ectcMouseOver))
				{
					ClearCurrentMouseOverTracking(true);
				}
				if(ectcHotTrack_ScrollLeft == (m_dwTabCtrlState & ectcHotTrack))
				{
					ClearCurrentHotTracking(true);
				}
			}

			if(hit.flags == CTCHT_ONITEM)
			{
				if( ectcMouseOver_TabItem != (m_dwTabCtrlState & ectcMouseOver))
				{
					ClearCurrentMouseOverTracking(true);
					m_dwTabCtrlState |= ectcMouseOver_TabItem;

					// Not needed for simple hot tracking:
					//if(ectcMouseDown_TabItem == (m_dwTabCtrlState & ectcMouseDown))
					//{
					//	this->InvalidateRect(&m_rcTabItemArea);
					//}
				}
				else if( CTCS_HOTTRACK == (dwStyle & CTCS_HOTTRACK) )
					// && ectcHotTrack_TabItem != (m_dwTabCtrlState & ectcHotTrack))
				{
					ClearCurrentHotTracking(true);

					ATLASSERT(nIndex >= 0);
					IntenalSetHotItem(nIndex);

					m_dwTabCtrlState |= ectcHotTrack_TabItem;
					RECT rcItem;
					this->GetItemRect(nIndex, &rcItem);
					this->InvalidateRect(&rcItem);
				}
			}
			else
			{
				if(ectcMouseOver_TabItem == (m_dwTabCtrlState & ectcMouseOver))
				{
					ClearCurrentMouseOverTracking(true);
				}
				if( CTCS_HOTTRACK == (dwStyle & CTCS_HOTTRACK) &&
					ectcHotTrack_TabItem == (m_dwTabCtrlState & ectcHotTrack))
				{
					ClearCurrentHotTracking(true);
				}
			}
		}

		return 1;
	}

	LRESULT OnMouseLeave(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& bHandled)
	{
		bHandled = FALSE;

		m_dwTabCtrlState &= ~ectcMouseInWindow;
		ClearCurrentHotTracking(false);
		ClearCurrentMouseOverTracking(false);

		T* pT = static_cast<T*>(this);
		pT->UpdateLayout();
		this->Invalidate();

		return 0;
	}

	LRESULT OnCaptureChanged(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
	{
		bHandled = FALSE;
		ClearCurrentMouseDownTracking(false);
		return 0;
	}

	LRESULT OnLButtonDown(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& /*bHandled*/)
	{
		T* pT = static_cast<T*>(this);
		// hit test
		CTCHITTESTINFO hit = { GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam) };
		int nIndex = HitTest(&hit);

		if(hit.flags == CTCHT_ONCLOSEBTN)
		{
			m_dwTabCtrlState |= (ectcMouseDown_CloseButton | ectcMouseOver_CloseButton);
			this->InvalidateRect(GetCloseButtonRect());
			this->SetCapture();
		}
		else if(hit.flags == CTCHT_ONSCROLLRIGHTBTN)
		{
			m_dwTabCtrlState |= (ectcMouseDown_ScrollRight | ectcMouseOver_ScrollRight);
			if(ectcOverflowRight == (m_dwTabCtrlState & ectcOverflowRight))
			{
				int nScrollSpeed = 0;
				switch(m_dwTabCtrlState & ectcScrollRepeat)
				{
				case ectcScrollRepeat_Slow:
					nScrollSpeed = CTCSR_SLOW;
					break;
				case ectcScrollRepeat_Normal:
					nScrollSpeed = CTCSR_NORMAL;
					break;
				case ectcScrollRepeat_Fast:
					nScrollSpeed = CTCSR_FAST;
					break;
				case ectcScrollRepeat_None:
				default:
					nScrollSpeed = CTCSR_NONE;
					break;
				}

				pT->ScrollRight(true);
				this->SetTimer(ectcTimer_ScrollRight, nScrollSpeed);
			}
			this->SetCapture();
		}
		else if(hit.flags == CTCHT_ONSCROLLLEFTBTN)
		{
			m_dwTabCtrlState |= (ectcMouseDown_ScrollLeft | ectcMouseOver_ScrollLeft);
			if(ectcOverflowLeft == (m_dwTabCtrlState & ectcOverflowLeft))
			{
				int nScrollSpeed = 0;
				switch(m_dwTabCtrlState & ectcScrollRepeat)
				{
				case ectcScrollRepeat_Slow:
					nScrollSpeed = CTCSR_SLOW;
					break;
				case ectcScrollRepeat_Normal:
					nScrollSpeed = CTCSR_NORMAL;
					break;
				case ectcScrollRepeat_Fast:
					nScrollSpeed = CTCSR_FAST;
					break;
				case ectcScrollRepeat_None:
				default:
					nScrollSpeed = CTCSR_NONE;
					break;
				}

				pT->ScrollLeft(true);
				this->SetTimer(ectcTimer_ScrollLeft, nScrollSpeed);
			}
			this->SetCapture();
		}
		else if(nIndex >= 0)
		{
			NMCTCMOUSE nmh = {{ m_hWnd, m_idDlgCtrl, CTCN_MOUSE }, nIndex, WM_LBUTTONDOWN, {hit.pt.x, hit.pt.y, hit.flags} };
			if(FALSE == ::SendMessage(GetParent(), WM_NOTIFY, nmh.hdr.idFrom, (LPARAM)&nmh))
			{
				// returning FALSE let's us do our default handling
				if( nIndex!=-1 )
				{
					pT->SetFocus();
					pT->SetCurSel(nIndex);
				}
			}
		}

		return 0;
	}

	LRESULT OnLButtonUp(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& /*bHandled*/)
	{
		if(m_hWnd == ::GetCapture())
		{
			POINT ptMouse = {GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam)};

			// Search for a tab
			T* pT = static_cast<T*>(this);
			CTCHITTESTINFO hit = { 0 };
			hit.pt = ptMouse;
			int nIndex = pT->HitTest(&hit);

			// Before we release the capture, remember what the state was
			// (in WM_CAPTURECHANGED we ClearCurrentMouseDownTracking)
			DWORD dwState = m_dwTabCtrlState;

			::ReleaseCapture();

			NMCTCMOUSE nmh = {{ m_hWnd, m_idDlgCtrl, CTCN_MOUSE }, nIndex, WM_LBUTTONUP, {ptMouse.x, ptMouse.y, hit.flags} };

			if(FALSE == ::SendMessage(GetParent(), WM_NOTIFY, nmh.hdr.idFrom, (LPARAM)&nmh))
			{
				if(ectcMouseDown_CloseButton == (dwState & ectcMouseDown) &&
					ectcMouseOver_CloseButton == (dwState & ectcMouseOver))
				{
					// Close Button
					NMCTCITEM nmh = {{ m_hWnd, m_idDlgCtrl, CTCN_CLOSE }, 0, {ptMouse.x, ptMouse.y}};
					::SendMessage(GetParent(), WM_NOTIFY, nmh.hdr.idFrom, (LPARAM)&nmh);
				}

				T* pT = static_cast<T*>(this);
				pT->UpdateLayout();
				this->Invalidate();
			}
		}
		return 0;
	}

	LRESULT OnLButtonDoubleClick(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& /*bHandled*/)
	{
		POINT ptMouse = {GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam)};

		// Search for a tab
		T* pT = static_cast<T*>(this);
		CTCHITTESTINFO hit = { 0 };
		hit.pt = ptMouse;
		int nIndex = pT->HitTest(&hit);

		// returning TRUE tells us not to do our default handling
		NMCTCMOUSE nmh = {{ m_hWnd, m_idDlgCtrl, CTCN_MOUSE }, nIndex, WM_LBUTTONDBLCLK, {ptMouse.x, ptMouse.y, hit.flags} };
		::SendMessage(GetParent(), WM_NOTIFY, nmh.hdr.idFrom, (LPARAM)&nmh);

		return 0;
	}

	LRESULT OnRButtonDown(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& /*bHandled*/)
	{
		POINT ptMouse = {GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam)};

		// Search for a tab
		T* pT = static_cast<T*>(this);
		CTCHITTESTINFO hit = { 0 };
		hit.pt = ptMouse;
		int nIndex = pT->HitTest(&hit);

		// returning TRUE tells us not to do our default handling
		NMCTCMOUSE nmh = {{ m_hWnd, m_idDlgCtrl, CTCN_MOUSE }, nIndex, WM_RBUTTONDOWN, {ptMouse.x, ptMouse.y, hit.flags} };
		if(FALSE == ::SendMessage(GetParent(), WM_NOTIFY, nmh.hdr.idFrom, (LPARAM)&nmh))
		{
			// returning FALSE let's us do our default handling
			if( nIndex!=-1 )
			{
				pT->SetFocus();
				pT->SetCurSel(nIndex);
			}
		}

		return 0;
	}

	LRESULT OnRButtonUp(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& bHandled)
	{
		POINT ptMouse = {GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam)};

		// Search for a tab
		T* pT = static_cast<T*>(this);
		CTCHITTESTINFO hit = { 0 };
		hit.pt = ptMouse;
		int nIndex = pT->HitTest(&hit);

		NMCTCMOUSE nmh = {{ m_hWnd, m_idDlgCtrl, CTCN_MOUSE }, nIndex, WM_RBUTTONUP, {ptMouse.x, ptMouse.y, hit.flags} };

		if(FALSE == ::SendMessage(GetParent(), WM_NOTIFY, nmh.hdr.idFrom, (LPARAM)&nmh))
		{
		}

		return 0;
	}

	LRESULT OnRButtonDoubleClick(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& /*bHandled*/)
	{
		POINT ptMouse = {GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam)};

		// Search for a tab
		T* pT = static_cast<T*>(this);
		CTCHITTESTINFO hit = { 0 };
		hit.pt = ptMouse;
		int nIndex = pT->HitTest(&hit);

		// returning TRUE tells us not to do our default handling
		NMCTCMOUSE nmh = {{ m_hWnd, m_idDlgCtrl, CTCN_MOUSE }, nIndex, WM_RBUTTONDBLCLK, {ptMouse.x, ptMouse.y, hit.flags} };
		::SendMessage(GetParent(), WM_NOTIFY, nmh.hdr.idFrom, (LPARAM)&nmh);

		return 0;
	}

	LRESULT OnMButtonMessage(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		POINT ptMouse = {GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam)};

		// Search for a tab
		T* pT = static_cast<T*>(this);
		CTCHITTESTINFO hit = { 0 };
		hit.pt = ptMouse;
		int nIndex = pT->HitTest(&hit);

		NMCTCMOUSE nmh = {{ m_hWnd, m_idDlgCtrl, CTCN_MOUSE }, nIndex, uMsg, {ptMouse.x, ptMouse.y, hit.flags} };

		if(FALSE == ::SendMessage(GetParent(), WM_NOTIFY, nmh.hdr.idFrom, (LPARAM)&nmh))
		{
			// returning FALSE let's us do our default handling
			if( nIndex!=-1 )
			{
				//pT->DeleteItem(nIndex);
			}
		}

		return 0;
	}
	
#if 0
	LRESULT OnKeyDown(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& bHandled)
	{
		T* pT = static_cast<T*>(this);
		switch( wParam )
		{
		case VK_LEFT:
			if( GetCurSel()>0 )
			{
				pT->SetCurSel(GetCurSel()-1);
			}
			return 0;
		case VK_RIGHT:
			if( GetCurSel()<(int)GetItemCount()-1 )
			{
				pT->SetCurSel(GetCurSel()+1);
			}
			return 0;
		}
		bHandled = FALSE;
		return 0;
	}
#endif
	LRESULT OnStyleChanged(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		if(wParam == GWL_STYLE)
		{
			LPSTYLESTRUCT pStyles = (LPSTYLESTRUCT)lParam;
			if(pStyles)
			{
				T* pT = static_cast<T*>(this);

				// Tooltips
				if((((pStyles->styleOld) & CTCS_TOOLTIPS) != CTCS_TOOLTIPS) &&
					(((pStyles->styleNew) & CTCS_TOOLTIPS) == CTCS_TOOLTIPS))
				{
					this->ActivateTooltips(TRUE);
				}
				else if((((pStyles->styleOld) & CTCS_TOOLTIPS) == CTCS_TOOLTIPS) &&
					(((pStyles->styleNew) & CTCS_TOOLTIPS) != CTCS_TOOLTIPS))
				{
					this->ActivateTooltips(FALSE);
				}

				// Scroll to fit
				if((((pStyles->styleOld) & CTCS_SCROLL) != CTCS_SCROLL) &&
					(((pStyles->styleNew) & CTCS_SCROLL) == CTCS_SCROLL))
				{
					if(m_tooltip.IsWindow())
					{
						m_tooltip.AddTool(m_hWnd, _T("Scroll Right"), &rcDefault, ectcToolTip_ScrollRight);
						m_tooltip.AddTool(m_hWnd, _T("Scroll Left"), &rcDefault, ectcToolTip_ScrollLeft);
					}

					//pT->UpdateLayout();
					//this->Invalidate();
				}
				else if((((pStyles->styleOld) & CTCS_SCROLL) == CTCS_SCROLL) &&
					(((pStyles->styleNew) & CTCS_SCROLL) != CTCS_SCROLL))
				{
					if(m_tooltip.IsWindow())
					{
						m_tooltip.DelTool(m_hWnd, ectcToolTip_ScrollRight);
						m_tooltip.DelTool(m_hWnd, ectcToolTip_ScrollLeft);
					}

					m_iScrollOffset = 0;
					//pT->UpdateLayout();
					//this->Invalidate();
				}

				// Close Button
				if((((pStyles->styleOld) & CTCS_CLOSEBUTTON) != CTCS_CLOSEBUTTON) &&
					(((pStyles->styleNew) & CTCS_CLOSEBUTTON) == CTCS_CLOSEBUTTON))
				{
					if(m_tooltip.IsWindow())
					{
						m_tooltip.AddTool(m_hWnd, _T("Close"), &rcDefault, ectcToolTip_Close);
					}

					//pT->UpdateLayout();
					//this->Invalidate();
				}
				else if((((pStyles->styleOld) & CTCS_CLOSEBUTTON) == CTCS_CLOSEBUTTON) &&
					(((pStyles->styleNew) & CTCS_CLOSEBUTTON) != CTCS_CLOSEBUTTON))
				{
					if(m_tooltip.IsWindow())
					{
						m_tooltip.DelTool(m_hWnd, ectcToolTip_Close);
					}

					//pT->UpdateLayout();
					//this->Invalidate();
				}

				pT->UpdateLayout();
				this->Invalidate();
			}
		}

		bHandled = FALSE;
		return 0;
	}

	LRESULT OnTimer(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& bHandled)
	{
		switch(wParam)
		{
		case ectcTimer_ScrollRight:
			if(ectcMouseDown_ScrollRight == (m_dwTabCtrlState & ectcMouseDown) &&
				ectcOverflowRight == (m_dwTabCtrlState & ectcOverflowRight))
			{
				if(ectcMouseOver_ScrollRight == (m_dwTabCtrlState & ectcMouseOver))
				{
					T* pT = static_cast<T*>(this);
					pT->ScrollRight(true);

					if(ectcScrollRepeat_None == (m_dwTabCtrlState & ectcScrollRepeat))
					{
						this->KillTimer(ectcTimer_ScrollRight);
					}
				}
			}
			else
			{
				this->KillTimer(ectcTimer_ScrollRight);
			}
			break;
		case ectcTimer_ScrollLeft:
			if(ectcMouseDown_ScrollLeft == (m_dwTabCtrlState & ectcMouseDown) &&
				ectcOverflowLeft == (m_dwTabCtrlState & ectcOverflowLeft))
			{
				if(ectcMouseOver_ScrollLeft == (m_dwTabCtrlState & ectcMouseOver))
				{
					T* pT = static_cast<T*>(this);
					pT->ScrollLeft(true);

					if(ectcScrollRepeat_None == (m_dwTabCtrlState & ectcScrollRepeat))
					{
						this->KillTimer(ectcTimer_ScrollLeft);
					}
				}
			}
			else
			{
				this->KillTimer(ectcTimer_ScrollLeft);
			}
			break;
		default:
			bHandled = FALSE;
			break;
		}
		return 0;
	}

	LRESULT OnSetRedraw(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& bHandled)
	{
		// If someone sends us WM_SETREDRAW with FALSE, we can avoid
		// doing an update layout until they set it back to TRUE.
		if(wParam)
		{
			if(ectcEnableRedraw != (m_dwTabCtrlState & ectcEnableRedraw))
			{
				// Redrawing was turned off, but now its being
				// turned back on again
				m_dwTabCtrlState |= ectcEnableRedraw;

				T* pT = static_cast<T*>(this);
				pT->UpdateLayout();

				// The caller will typically call InvalidateRect
				// or RedrawWindow after sending WM_SETREDRAW with TRUE,
				// so we won't do that here (but we will UpdateLayout,
				// so that we'll be ready to redraw)
			}
		}
		else
		{
			if(ectcEnableRedraw == (m_dwTabCtrlState & ectcEnableRedraw))
			{
				// Redrawing was turned on, but now its being turned off
				m_dwTabCtrlState &= ~ectcEnableRedraw;
			}
		}

		bHandled = FALSE;
		return 0;
	}

	LRESULT OnGetToolTipInfo(int /*idCtrl*/, LPNMHDR pnmh, BOOL& /*bHandled*/)
	{
		LPNMTTDISPINFO pToolTipInfo = (LPNMTTDISPINFO)pnmh;
		if(pToolTipInfo)
		{
			// The way we implement tooltips for tab items
			// is to have as many "tools" as there are tabs.
			// The relationship of tool ID => tab index is:
			// tool ID = tab index + 1	(to avoid 0 as an ID)
			//
			// We supply the RECT elsewhere and the text here
			UINT id = pToolTipInfo->hdr.idFrom;
			if(id > 0 && id <= (UINT)GetItemCount())
			{
				TItem* pItem = GetItem(id-1);
				if(pItem)
				{
					if(pItem->UsingToolTip())
					{
						pToolTipInfo->lpszText = const_cast<LPTSTR>(pItem->GetToolTip());
					}
					else if(pItem->UsingText())
					{
						pToolTipInfo->lpszText = const_cast<LPTSTR>(pItem->GetText());
					}
				}
			}
		}

		return 0;
	}

// Overridables
public:
	void UpdateLayout(void)
	{
		if(	!m_hWnd ||
			!::IsWindow(m_hWnd) ||
			(ectcEnableRedraw != (m_dwTabCtrlState & ectcEnableRedraw)))
		{
			return;
		}

		T* pT = static_cast<T*>(this);
		CRect rcClient;
		this->GetClientRect(&rcClient);
		pT->CalcComponentSize(rcClient);
		if(m_tooltip.IsWindow())
		{
			m_tooltip.SetToolRect(m_hWnd, ectcToolTip_Close      , GetCloseButtonRect());
			m_tooltip.SetToolRect(m_hWnd, ectcToolTip_ScrollRight, GetScrollRightRect());
			m_tooltip.SetToolRect(m_hWnd, ectcToolTip_ScrollLeft , GetScrollLeftRect());
		}

		DWORD dwStyle = this->GetStyle();
		if(CTCS_SCROLL == (dwStyle & CTCS_SCROLL))
		{
			pT->UpdateLayout_ScrollToFit(rcClient);
			pT->UpdateScrollOverflowStatus();
		}
		else
		{
			pT->UpdateLayout_Default(rcClient);
		}

		pT->UpdateTabItemTooltipRects();
	}

	void UpdateTabItemTooltipRects(void)
	{
		// The way we implement tooltips for tab items
		// is to have as many "tools" as there are tabs.
		// The relationship of tool ID => tab index is:
		// tool ID = tab index + 1	(to avoid 0 as an ID)
		//
		// We supply the RECT here and text elsewhere.
		if(m_tooltip.IsWindow())
		{
			size_t i = 0;
			size_t nCount = GetItemCount();
			RECT rcIntersect;
			for(i=0; i<nCount; ++i )
			{
				RECT rcItemDP;
				this->GetItemRect(i, &rcItemDP);
				::IntersectRect(&rcIntersect, &rcItemDP, GetTabAreaRect());

				// NOTE: Even if IntersectRect determines the rectangles
				// don't intersect at all, we still need
				// to update the tool rect, or we'll get the wrong
				// tooltip in some cases.
				m_tooltip.SetToolRect(m_hWnd, i+1, &rcIntersect);
			}
		}
	}

	void ScrollLeft(bool bForceRedraw = true)
	{
		m_iScrollOffset += ((m_dwTabCtrlState & ectcScrollDeltaMask) >> ectcScrollDeltaShift);

		T* pT = static_cast<T*>(this);
		pT->UpdateLayout();
		pT->UpdateScrollOverflowStatus();
		pT->UpdateTabItemTooltipRects();
		if(bForceRedraw)
		{
			this->Invalidate();
			// If something a little more forceful is needed:
			//::RedrawWindow(m_hWnd, NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
		}
	}

	void ScrollRight(bool bForceRedraw = true)
	{
		m_iScrollOffset -= ((m_dwTabCtrlState & ectcScrollDeltaMask) >> ectcScrollDeltaShift);

		T* pT = static_cast<T*>(this);
		pT->UpdateLayout();
		pT->UpdateScrollOverflowStatus();
		pT->UpdateTabItemTooltipRects();
		if(bForceRedraw)
		{
			this->Invalidate();
			// If something a little more forceful is needed:
			//::RedrawWindow(m_hWnd, NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
		}
	}

	void UpdateScrollOverflowStatus(void)
	{
		// Check for overflow left
		if(m_iScrollOffset >= 0)
		{
			m_iScrollOffset = 0;
			m_dwTabCtrlState &= ~ectcOverflowLeft;
		}
		else
		{
			m_dwTabCtrlState |= ectcOverflowLeft;
		}

		// Check for overflow right
		m_dwTabCtrlState &= ~ectcOverflowRight;

		size_t nCount = GetItemCount();
		if(nCount > 0)
		{
			// Check last item
			RECT rcItemDP;
			this->GetItemRect(nCount-1, &rcItemDP);
			if(rcItemDP.right > GetTabAreaRect().right)
			{
				m_dwTabCtrlState |= ectcOverflowRight;
			}
		}
	}

	void DoPaint(CDCHandle dc, RECT &rcClip)
	{
		// Save current DC selections
		int nSave = dc.SaveDC();
		ATLASSERT(nSave!=0);

		DWORD dwStyle = this->GetStyle();

		// Make sure we don't paint outside client area (possible with paint dc)
		RECT rcClient;
		GetClientRect(&rcClient);
		dc.IntersectClipRect(&rcClient);

		// Prepare DC
		dc.SelectFont(this->GetFont());

		T* pT = static_cast<T*>(this);
		LRESULT lResCustom;
		NMCTCCUSTOMDRAW nmc = { 0 };
		LPNMCUSTOMDRAW pnmcd= &(nmc.nmcd);
		pnmcd->hdr.hwndFrom = m_hWnd;
		pnmcd->hdr.idFrom = m_idDlgCtrl;
		pnmcd->hdr.code = NM_CUSTOMDRAW;
		pnmcd->hdc = dc;
		pnmcd->uItemState = 0;

		pT->InitializeDrawStruct(&nmc, m_dwTabCtrlState);

		pnmcd->dwDrawStage = CDDS_PREPAINT;
		lResCustom = ::SendMessage(GetParent(), WM_NOTIFY, pnmcd->hdr.idFrom, (LPARAM)&nmc);

		if( CDRF_SKIPDEFAULT != (lResCustom & CDRF_SKIPDEFAULT) )
		{
			pT->DoPrePaint(rcClient, &nmc, m_dwTabCtrlState);
		}

		if( lResCustom==CDRF_DODEFAULT || CDRF_NOTIFYITEMDRAW==(lResCustom & CDRF_NOTIFYITEMDRAW) )
		{
			POINT ptPreviousViewport = {0};
			HRGN hRgnClip = NULL;

			bool bScrollStyle = (CTCS_SCROLL == (dwStyle & CTCS_SCROLL));
			bool bHotTrackStyle = (CTCS_HOTTRACK == (dwStyle & CTCS_HOTTRACK));

			if(bScrollStyle)
			{
				// Remember clip region before we modify it
				//  to only include the tab item area
				// NOTE: GetClipRgn expects an already created
				//  region, so we create one with an empty rectangle.
				hRgnClip = ::CreateRectRgn(0,0,0,0);
				::GetClipRgn(dc, hRgnClip);

				dc.IntersectClipRect(&m_rcTabItemArea);

				dc.SetViewportOrg(m_iScrollOffset, 0, &ptPreviousViewport);
			}

			size_t nCount = GetItemCount();
			// Draw the list items, except the selected one. It is drawn last
			// so it can cover the tabs below it.
			RECT rcIntersect;
			for( size_t i=0; i<nCount; ++i )
			{
				if(!GetSel(i))
				{
					RECT rcItemLP, rcItemDP;
					rcItemLP = GetItem(i)->GetRect();

					::CopyRect(&rcItemDP, &rcItemLP);
					::OffsetRect(&rcItemDP, m_iScrollOffset, 0);

					if( ::IntersectRect(&rcIntersect, &rcItemDP, &rcClip) )
					{
						pnmcd->dwItemSpec = i;
						pnmcd->uItemState = 0;
						if(bHotTrackStyle && ((DWORD)GetHotItem() == i))
						{
							pnmcd->uItemState |= CDIS_HOT;
						}
						pnmcd->rc = rcItemLP;
						pT->ProcessItem(lResCustom, &nmc, m_dwTabCtrlState);
					}
				}
			}
			if( GetCurSel() >=0 && (size_t)GetCurSel() < nCount )
			{
				RECT rcItemLP, rcItemDP;
				rcItemLP = GetItem(GetCurSel())->GetRect();

				::CopyRect(&rcItemDP, &rcItemLP);
				::OffsetRect(&rcItemDP, m_iScrollOffset, 0);

				if( ::IntersectRect(&rcIntersect, &rcItemDP, &rcClip) )
				{
					pnmcd->dwItemSpec = GetCurSel();
					pnmcd->uItemState = CDIS_SELECTED;
					if(bHotTrackStyle && GetSel(GetHotItem()))
					{
						pnmcd->uItemState |= CDIS_HOT;
					}
					pnmcd->rc = rcItemLP;
					pT->ProcessItem(lResCustom, &nmc, m_dwTabCtrlState);
				}
			}
			pnmcd->uItemState = 0;
			pnmcd->dwItemSpec = 0;

			if(bScrollStyle)
			{
				dc.SetViewportOrg(ptPreviousViewport);

				dc.SelectClipRgn(hRgnClip);
				::DeleteObject(hRgnClip);
			}
		}

		if( CDRF_SKIPDEFAULT != (lResCustom & CDRF_SKIPDEFAULT) )
		{
			pT->DoPostPaint(rcClient, &nmc, m_dwTabCtrlState);
		}
		
		if( CDRF_NOTIFYPOSTPAINT == (lResCustom & CDRF_NOTIFYPOSTPAINT) )
		{
			pnmcd->dwDrawStage = CDDS_POSTPAINT;
			pnmcd->dwItemSpec = 0;
			pnmcd->uItemState = 0;
			pnmcd->rc = rcClient;
			::SendMessage(GetParent(), WM_NOTIFY, pnmcd->hdr.idFrom, (LPARAM)&nmc);
		}

		dc.RestoreDC(nSave);
	}

// Operations
public:
	CToolTipCtrl GetTooltips() const
	{
		return m_tooltip;
	}

	bool SetScrollDelta(UINT nDelta)
	{
		if(nDelta > (ectcScrollDeltaMask >> ectcScrollDeltaShift))
		{
			return false;
		}
		m_dwTabCtrlState |=  ((nDelta << ectcScrollDeltaShift) & ectcScrollDeltaMask);

		return true;
	}

	UINT GetScrollDelta(void)
	{
		return ((m_dwTabCtrlState & ectcScrollDeltaMask) >> ectcScrollDeltaShift);
	}

	bool SetScrollRepeat(ScrollRepeat ectcNewScrollRepeat = ectcScrollRepeat_Normal)
	{
		m_dwTabCtrlState &= ~ectcScrollRepeat;
		m_dwTabCtrlState |= (ectcNewScrollRepeat & ectcScrollRepeat);

		return true;
	}

	ScrollRepeat GetScrollRepeat(void)
	{
		return (m_dwTabCtrlState & ectcScrollRepeat);
	}

	int GetScrollOffset() const
	{
		return m_iScrollOffset;
	}

	void SetScrollOffset(int offset)
	{
		m_iScrollOffset = offset;
	}

	int InsertItem(int nItem, LPCTSTR sText = NULL, int nImage = -1, LPCTSTR sToolTip = NULL, bool bSelectItem = false)
	{
		T* pT = static_cast<T*>(this);
		TItem* pItem = pT->CreateNewItem();
		if(pItem)
		{
			pItem->SetText(sText);
			pItem->SetImageIndex(nImage);
			pItem->SetToolTip(sToolTip);

			return InsertItem(nItem, pItem, bSelectItem);
		}
		return -1;
	}

	int InsertItem(int nItem, TItem* pItem, bool bSelectItem = false)
	{
		T* pT = static_cast<T*>(this);

		ATLASSERT(::IsWindow(m_hWnd));
		ATLASSERT(pItem);
		ATLASSERT(nItem >=0 && nItem <= (int)GetItemCount());
		if(!::IsWindow(m_hWnd) || pItem == NULL)
		{
			return -1;
		}

		size_t nOldCount = GetItemCount();

		if( nItem < 0 || nItem > (int)nOldCount )
		{
			nItem = nOldCount;
		}

		InternalInsertItem(nItem, pItem);

		size_t nNewCount = GetItemCount();

		// Send notification
		NMCTCITEM nmh = {{ m_hWnd, m_idDlgCtrl, CTCN_INSERTITEM }, nItem, {-1,-1}};
		::SendMessage(GetParent(), WM_NOTIFY, nmh.hdr.idFrom, (LPARAM)&nmh);
		// Select if first tab
		if( nNewCount==1 )
		{
			pT->SetCurSel(0);
		}
		else if(bSelectItem)
		{
			pT->SetCurSel(nItem);
		}

		if(m_tooltip.IsWindow())
		{
			m_tooltip.AddTool(m_hWnd, LPSTR_TEXTCALLBACK, &rcDefault, nNewCount);
		}

		pT->UpdateLayout();
		this->Invalidate();
		return nItem;
	}

	BOOL MoveItem(size_t nFromIndex, size_t nToIndex, bool bUpdateSelection = true, bool bNotify = true)
	{
		T* pT = static_cast<T*>(this);

		ATLASSERT(::IsWindow(m_hWnd));
		ATLASSERT(nFromIndex < GetItemCount());
		ATLASSERT(nToIndex < GetItemCount());

		if(!::IsWindow(m_hWnd) || nFromIndex >= GetItemCount() || nToIndex >= GetItemCount())
		{
			return FALSE;
		}

		TItem* pFromItem = m_Items[nFromIndex];
		m_Items.RemoveAt(nFromIndex);
		m_Items.InsertAt(nToIndex, pFromItem);

		// The number of items is staying the same, so m_iCurSel
		// won't be invalid whether it gets updated or not
		if(bUpdateSelection)
		{
			if(nFromIndex == (size_t)m_iCurSel)
			{
				pT->SetCurSel(nToIndex);
			}
		}

		if(bNotify)
		{
			NMCTC2ITEMS nmh = {{ m_hWnd, m_idDlgCtrl, CTCN_MOVEITEM }, nFromIndex, nToIndex, {-1,-1}};
			::SendMessage(GetParent(), WM_NOTIFY, nmh.hdr.idFrom, (LPARAM)&nmh);
		}

		return TRUE;
	}

	BOOL SwapItemPositions(size_t nFromIndex, size_t nToIndex, bool bUpdateSelection = true, bool bNotify = true)
	{
		T* pT = static_cast<T*>(this);

		ATLASSERT(::IsWindow(m_hWnd));
		ATLASSERT(nFromIndex < GetItemCount());
		ATLASSERT(nToIndex < GetItemCount());

		if(!::IsWindow(m_hWnd) || nFromIndex >= GetItemCount() || nToIndex >= GetItemCount())
		{
			return FALSE;
		}

		TItem* pFromItem = m_Items[nFromIndex];
		TItem* pToItem = m_Items[nToIndex];
		m_Items[nFromIndex] = pToItem;
		m_Items[nToIndex] = pFromItem;

		// The number of items is staying the same, so m_iCurSel
		// won't be invalid whether it gets updated or not
		if(bUpdateSelection)
		{
			if(nFromIndex == (size_t)m_iCurSel)
			{
				pT->SetCurSel(nToIndex);
			}
			else if(nToIndex == (size_t)m_iCurSel)
			{
				pT->SetCurSel(nFromIndex);
			}
		}

		if(bNotify)
		{
			NMCTC2ITEMS nmh = {{ m_hWnd, m_idDlgCtrl, CTCN_SWAPITEMPOSITIONS }, nFromIndex, nToIndex, {-1,-1}};
			::SendMessage(GetParent(), WM_NOTIFY, nmh.hdr.idFrom, (LPARAM)&nmh);
		}

		return TRUE;
	}

	BOOL DeleteItem(size_t nItem, bool bUpdateSelection = true, bool bNotify = true)
	{
		T* pT = static_cast<T*>(this);
		ATLASSERT(::IsWindow(m_hWnd));
		size_t nOldCount = GetItemCount();
		if( nItem >= nOldCount )
		{
			return FALSE;
		}

		UINT nCurSel = GetCurSel();

		// Send notification
		if(bNotify)
		{
			// Returning TRUE tells us not to delete the item
			NMCTCITEM nmh = {{ m_hWnd, m_idDlgCtrl, CTCN_DELETEITEM }, nItem, {-1,-1}};
			if( TRUE == ::SendMessage(GetParent(), WM_NOTIFY, nmh.hdr.idFrom, (LPARAM)&nmh) )
			{
				// Cancel the attempt
				return FALSE;
			}
			else
			{
				// Just in case handler of the notification
				// changed the count somehow, get it again
				nOldCount = GetItemCount();
				if( nItem >= nOldCount )
				{
					return FALSE;
				}
			}
		}

		int nPostDeleteSelection = -1;

		// The number of items is changing, so m_iCurSel
		// might be invalid if we don't change it.
		if(nOldCount <= 1)
		{
			// There's only one item left,
			// and its being deleted.
			pT->SetCurSel(-1);
		}
		else if(bUpdateSelection)
		{
			if( (int)nItem < nCurSel )
			{
				// The item being removed is before the current selection.
				// We still want the same item to be selected, but
				// the index needs to be adjusted to account for the missing item
				SetCurSel(nCurSel-1);
				pT->EnsureVisible(GetCurSel());
				// NOTE: We don't call SetCurSel because we don't want
				//  any of the notifications to go to the parent - because
				//  the selection didn't change, the index just had to be adjusted.
			}
			else if( (int)nItem == nCurSel )
			{
				// If the item to be deleted is currently selected,
				//  select something else.
				// NOTE: We've already handled the "we're deleting
				//  the only remaining item" case.
				if(nItem >= (nOldCount-1))
				{
					// The selected item was the last item,
					// and there will still be at least one
					// item after this deletion occurs.
					// Select the item that will be the
					// new last item.
					// We need to do this before the actual
					// deletion so that m_iCurSel
					// will still be valid during the SetCurSel
					// call and the notification handlers of
					// CTCN_SELCHANGING and CTCN_SELCHANGE
					pT->SetCurSel(nCurSel-1);
				}
				else
				{
					// 폜܂ACe͎cĂāA
					// IĂACe͍폜ꂽACe荶B
					// IACe͕ύXȂB
					nPostDeleteSelection = nCurSel;
				}
			}
		}
		else
		{
			if(((int)nItem == nCurSel) && (nItem >= (nOldCount-1)))
			{
				// If bUpdateSelection is false,
				// the item being deleted is selected,
				// and the item being deleted is the last
				// item, we need to clear the current selection
				// (setting m_iCurSel to -1)
				// so that our call to UpdateLayout
				// and our paint message handling don't
				// crash and burn with an invalid selected
				// item index. Its likely that the
				// caller is going to SetCurSel right
				// after this call to DeleteItem.
				SetCurSel(-1);
			}
		}

		// Remove tooltip and item

		// The way we implement tooltips is to have as many
		// "tools" as there are tabs.  The relationship of
		// tool ID => tab index is:
		// tool ID = tab index + 1	(to avoid 0 as an ID)
		//
		// We supply the RECT and text elsewhere.
		if(m_tooltip.IsWindow())
		{
			m_tooltip.DelTool(m_hWnd, GetItemCount());
		}

		TItem* pItem = GetItem(nItem);
		InternalRemoveItem(nItem);

		pT->FreeItem(pItem);

		if(nPostDeleteSelection >= 0)
		{
			pT->SetCurSel(nPostDeleteSelection);
		}

		// Repaint
		pT->UpdateLayout();
		this->Invalidate();
		return TRUE;
	}

	BOOL DeleteAllItems(bool bForceRedraw = false)
	{
		ATLASSERT(::IsWindow(m_hWnd));
		InternalSetCurSel(-1);

		this->SendMessage(WM_SETREDRAW, FALSE, 0);

		while( GetItemCount()>0 ) DeleteItem(0U, false, true);

		this->SendMessage(WM_SETREDRAW, TRUE, 0);

		// UpdateLayout will already have been called
		// when sending WM_SETREDRAW with TRUE after
		// having sent it with FALSE
		// (or in DeleteItem if we weren't doing WM_SETREDRAW stuff)
		if(bForceRedraw)
		{
			this->Invalidate();
			// If something a little more forceful is needed:
			//::RedrawWindow(m_hWnd, NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW);
		}

		return TRUE;
	}

	int SetCurSel(int nItem, bool bNotify = true)
	{
		T* pT = static_cast<T*>(this);
		ATLASSERT(::IsWindow(m_hWnd));

		// NEW (DDB):
		// Even if the newly requested selection index is
		// the same index as the previous selection index,
		// the item might be different (as in the case of
		// InsertItem inserting a new item where the old
		// selection used to be).  We also call EnsureVisible
		// and UpdateLayout in this method, which we will want
		// called even if it is the same item
		//
		// OLD:
		// // Selecting same tab?  If so, we won't go through all the notifications
		// if( (int)nItem==m_iCurSel ) return m_iCurSel;

		if( nItem >= (int)GetItemCount() )
		{
			nItem = GetCurSel();
		}

		int iOldSel = GetCurSel();
		// Send notification
		NMCTC2ITEMS nmh = {{ m_hWnd, m_idDlgCtrl, CTCN_SELCHANGING }, iOldSel, nItem, {-1,-1}};
		if(bNotify)
		{
			if( TRUE == ::SendMessage(GetParent(), WM_NOTIFY, nmh.hdr.idFrom, (LPARAM)&nmh) )
			{
				// Cancel the attempt
				return -1;
			}
		}

		// Change tab
		InternalSetCurSel(nItem);

		if(GetCurSel() >= 0)
		{
			pT->EnsureVisible(GetCurSel());
		}

		// Recalc new layout and redraw
		pT->UpdateLayout();
		this->Invalidate();

		if(bNotify)
		{
			// Send notification
			nmh.hdr.code = CTCN_SELCHANGE;
			::SendMessage(GetParent(), WM_NOTIFY, nmh.hdr.idFrom, (LPARAM)&nmh);
		}
		return iOldSel;
	}

	bool EnsureVisible(int nItem, bool bPartialOK = false, bool bRecalcAndRedraw = false)
	{
		bool bAdjusted = false;
		const CRect& rcTabItemArea = GetTabAreaRect();

		// Adjust scroll offset so that item is visible
		if(0 != (m_dwTabCtrlState & (ectcOverflowLeft|ectcOverflowRight)))
		{
			if(nItem < 0 || nItem >= (int)GetItemCount())
			{
				return false;
			}

			// TODO: Depend on some system metric for this value
			int nScrollToViewPadding = 20;

			RECT rcItemDP;
			this->GetItemRect(nItem, &rcItemDP);
			if(rcItemDP.left < rcTabItemArea.left)
			{
				if(!bPartialOK || (rcItemDP.right < rcTabItemArea.left))
				{
					m_iScrollOffset += (rcTabItemArea.left-rcItemDP.left) + nScrollToViewPadding;
					bAdjusted = true;
				}
			}
			else if(rcItemDP.right > rcTabItemArea.right)
			{
				if(!bPartialOK || (rcItemDP.left > rcTabItemArea.right))
				{
					m_iScrollOffset -= (rcItemDP.right-rcTabItemArea.right) + nScrollToViewPadding;
					bAdjusted = true;
				}
			}

			// Note: UpdateLayout should call UpdateScrollOverflowStatus which
			//  will catch m_iScrollOffset being scrolled too far either direction
		}

		if(bAdjusted && bRecalcAndRedraw)
		{
			T* pT = static_cast<T*>(this);
			if(bRecalcAndRedraw)
			{
				pT->UpdateLayout();
				this->Invalidate();
			}
			else
			{
				pT->UpdateScrollOverflowStatus();
				pT->UpdateTabItemTooltipRects();
			}
		}

		return true;
	}

	int GetRowCount() const
	{
		return 1;
	}

	BOOL GetItemRect(size_t nItem, RECT *prcItem) const
	{
		ATLASSERT(prcItem);
		if( prcItem==NULL ) return FALSE;
		if( nItem >= (size_t)GetItemCount() )
		{
			::SetRectEmpty(prcItem);
			return FALSE;
		}
		*prcItem = GetItem(nItem)->GetRect();

		// Adjust for any scroll, so that the caller
		// gets the RECT in device coordinates
		// instead of logical coordinates
		::OffsetRect(prcItem, m_iScrollOffset, 0);

		return TRUE;
	}

	void SetPadding(int iPadding) 
	{ 
		m_iPadding = iPadding; 
		T* pT = static_cast<T*>(this);
		pT->UpdateLayout();
		this->Invalidate();
	};
};

#endif // __CUSTOMTABCTRL_H__

