// FileListCtrl.h
#pragma once

#include "ShellUtil.h"
#include "Keyboard.h"

// 
// GetItemObject(SVGIO_FLAG_VIEWORDER) Ŏ擾ACȅԂ́A
// ListViewCtrl ł̃CfbNXƈv悤B

namespace mew {

/////////////////////////////////////////////////////////////////////////////
// Classes in this file
//
// CShellBrowserImpl<T>
// CShellListView
// CFileListCtrlImpl<T, TBase, TWinTratis>
// CFileListCtrl

// IShellBrowserEBhE͂̃bZ[WȂĂ͂ȂȂB
const UINT WM_GETISHELLBROWSER = WM_USER+7;

////////////////////////////////////////////////////////////////////////

template < class T >
class CShellBrowserImpl : public IShellBrowser, public ICommDlgBrowser2
{
public:
	STDMETHOD(QueryInterface)(REFIID iid, void **ppvObject)
	{
		if(ppvObject == NULL)
			return E_POINTER;
		if(iid == IID_IUnknown)
			*ppvObject = (IUnknown*)static_cast<IShellBrowser*>(this);
		else if(iid == IID_IOleWindow)
			*ppvObject = static_cast<IOleWindow*>(this);			
		else if(iid == IID_IShellBrowser)
			*ppvObject = static_cast<IShellBrowser*>(this);
		else if(iid == IID_ICommDlgBrowser || iid == IID_ICommDlgBrowser2)
			*ppvObject = static_cast<ICommDlgBrowser2*>(this);
		else
			return *ppvObject = NULL, E_NOINTERFACE;
		AddRef();
		return S_OK;
	}
	STDMETHOD_(ULONG, AddRef)()  { return 1; }
	STDMETHOD_(ULONG, Release)() { return 1; }

	// *** IOleWindow methods ***
	STDMETHOD(GetWindow)(HWND * lphwnd)
	{ 
		*lphwnd = static_cast<HWND>(*static_cast<T*>(this));
		return S_OK; 
	}
    STDMETHOD(ContextSensitiveHelp)(BOOL fEnterMode){return E_NOTIMPL;}	

	// *** ICommDlgBrowser methods ***
    STDMETHOD(OnDefaultCommand) (IShellView * ppshv)
	{	//handle double click and ENTER key if needed
		return S_FALSE; 
	}
    STDMETHOD(OnStateChange) (IShellView * ppshv,ULONG uChange)
	{	//handle selection, rename, focus if needed
		// CDBOSC_SETFOCUS  The focus has been set to the view. 
		// CDBOSC_KILLFOCUS  The view has lost the focus.  
		// CDBOSC_SELCHANGE  The selected item has changed. 
		// CDBOSC_RENAME  An item has been renamed. 
		// CDBOSC_STATECHANGE  An item has been checked or unchecked 
		return E_NOTIMPL; 
	}
    STDMETHOD(IncludeObject) (IShellView * ppshv,LPCITEMIDLIST pidl)
	{	// \t@C̃tB^OB
		// S_OK: show, S_FALSE: hide
		return S_OK;
	}

	// *** ICommDlgBrowser2 methods ***
	STDMETHODIMP GetDefaultMenuText(IShellView *pshv, WCHAR *pszText, int cchMax)
	{
		return S_FALSE;
	}
	STDMETHODIMP GetViewFlags(DWORD *pdwFlags)
	{	// ׂẴt@C\ׂۂ̖₢킹B
		// CDB2GVF_SHOWALLFILES: Bt@C\B
		// 0: Bt@C\ȂB
		//*pdwFlags = CDB2GVF_SHOWALLFILES;
		return S_OK;
	}
	STDMETHODIMP Notify(IShellView *pshv, DWORD dwNotifyType)
	{
		return S_OK;
	}

	// *** IShellBrowser methods *** (same as IOleInPlaceFrame)
    STDMETHOD(InsertMenusSB) (HMENU hmenuShared, LPOLEMENUGROUPWIDTHS lpMenuWidths) {return E_NOTIMPL;}
    STDMETHOD(SetMenuSB) (HMENU hmenuShared, HOLEMENU holemenuReserved,HWND hwndActiveObject){return E_NOTIMPL;}
    STDMETHOD(RemoveMenusSB) (HMENU hmenuShared){return E_NOTIMPL;}
    STDMETHOD(SetStatusTextSB) (LPCOLESTR lpszStatusText){return E_NOTIMPL;}
    STDMETHOD(EnableModelessSB) (BOOL fEnable){return E_NOTIMPL;}
	STDMETHOD(BrowseObject)(LPCITEMIDLIST pidl, UINT wFlags){return E_NOTIMPL; }
	STDMETHOD(GetViewStateStream)(DWORD grfMode,LPSTREAM  *ppStrm){return E_NOTIMPL;}	
	STDMETHOD(OnViewWindowActive)(struct IShellView *ppshv){return E_NOTIMPL;}
	STDMETHOD(SetToolbarItems)(LPTBBUTTON lpButtons, UINT nButtons,UINT uFlags){return E_NOTIMPL;}
	STDMETHOD(TranslateAcceleratorSB) (LPMSG lpmsg, WORD wID) { return S_OK; }
	STDMETHOD(GetControlWindow)(UINT id, HWND * lphwnd){return E_NOTIMPL;}
	STDMETHOD(SendControlMsg)(UINT id, UINT uMsg, WPARAM wParam,LPARAM lParam, LRESULT *pret){return E_NOTIMPL;}
};

////////////////////////////////////////////////////////////////////////

// VFr[iSHELLDLL_DefViewj́AWM_CONTEXTMENU B
class CShellListView : public CWindowImpl<CShellListView>
{
public:
	LRESULT DefaultContextMenu(WPARAM wParam, LPARAM lParam)
	{
		// [vɊׂ̔邽߁ATuNXĂꍇ̂݁B
		if(m_pfnSuperWindowProc != ::DefWindowProc)
			return DefWindowProc(WM_CONTEXTMENU, wParam, lParam);
		return 0;
	}

public:
	BEGIN_MSG_MAP(CShellListView)
		MESSAGE_HANDLER(WM_CONTEXTMENU	, OnContextMenu)
	END_MSG_MAP()

	LRESULT OnContextMenu(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{	// ̂܂ܐeɓ]B
		::DefWindowProc(m_hWnd, uMsg, wParam, lParam);
		bHandled = TRUE;
		return 0;
	}
};

////////////////////////////////////////////////////////////////////////

struct CFileListCtrlTravelEntry
{
	CAutoPtr<CShellItemTask> pShellItem;
	TCHAR Name[MAX_PATH];
	TCHAR Path[MAX_PATH];

	CFileListCtrlTravelEntry(const CShellItem* pItem)
	{
		ZeroMemory(this, sizeof(CFileListCtrlTravelEntry));
		pShellItem = CShellItemTask::Duplicate(pItem);
		pShellItem->GetProperty(Name);
		if(!pShellItem->IsRoot())
		{	// fXNgbv́ApX͎擾łĂ܂AztH_̂ŁB
			pShellItem->GetPath(Path);
		}
	}
};

////////////////////////////////////////////////////////////////////////

template <class T, class TBase = CWindow, class TWinTraits = CControlWinTraits>
class ATL_NO_VTABLE CFileListCtrlImpl :
	public CWindowImpl<T, TBase, TWinTraits>,
	public CShellBrowserImpl<T>
{
private:
	static const size_t MAX_TRAVEL_LOG = 20;
	CAutoPtrArray<CFileListCtrlTravelEntry>	m_TravelLog;	// qXgB
	size_t					m_CurrentIndex;		// qXgł̃CfbNXB
	CComPtr<IShellFolder>	m_pCurrentFolder;	// ݕ\̃tH_
	CComPtr<IShellView>		m_pShellView;		// ݕ\̃r[
	CShellListView			m_ViewWindow;		// r[̃nhBAXgr[͂̎qB
	CListViewCtrl			m_ListCtrl;			// Xgr[B

public:
	DECLARE_WND_SUPERCLASS(NULL, TBase::GetWndClassName())

	CFileListCtrlImpl()
	{
		m_CurrentIndex = 0;
	}

	const CShellItem* GetCurrentFolderItem() const
	{
		return m_TravelLog[m_CurrentIndex]->pShellItem;
	}
	const CFileListCtrlTravelEntry* GetTravelEntry(INT index = 0, bool relative = true)
	{
		if(relative)
			index = (INT)m_CurrentIndex + index;
		if(index < 0 || index >= (INT)m_TravelLog.GetCount())
			return NULL;
		else
			return m_TravelLog[index];
	}
	void GetTravelEntryCount(size_t* current, size_t* length)
	{
		*current = m_CurrentIndex;
		*length  = m_TravelLog.GetCount();
	}

	IShellFolder*	GetCurrentFolder()		{ return m_pCurrentFolder; }
	IShellView*		GetShellView()			{ return m_pShellView; }
	CWindow			GetShellWindow()		{ return m_ViewWindow; } // SHELLDLL_DefView
	CListViewCtrl	GetListCtrl()			{ return m_ListCtrl; }
	bool IsEmpty() const	{ return m_pCurrentFolder == NULL; }

public: // I[o[Ch
	void UpdateLayout()
	{
		if(m_ViewWindow.IsWindow())
		{
			CRect rcClient;
			GetClientRect(&rcClient);
			m_ViewWindow.MoveWindow(rcClient);
		}
	}

	void UpdateFolderSettings(IShellView* pCurrent, IShellView* pNew, FOLDERSETTINGS* fs)
	{
		// [ViewMode]
		// FVM_ICON      = 1,
		// FVM_SMALLICON = 2,
    	// FVM_LIST      = 3,
    	// FVM_DETAILS   = 4,
    	// FVM_THUMBNAIL = 5,
    	// FVM_TILE      = 6,
    	// FVM_THUMBSTRIP= 7,
		//
		// [FOLDERFLAGS] ɂtO͂邪ALpȂ͉̂̂SB
		// FWF_AUTOARRANGE   : B̂̓WXg̐ݒ𔽉fłȂH
		// FWF_ALIGNLEFT     : ACRׂĕ\Ȃǂōl߂ɂȂBftHg͏l߁B
		// FWF_SHOWSELALWAYS : ȂƂXPł́A͏ONۂB
		// FWF_CHECKSELECT   : `FbN{bNXt[hB`FbNꂽACe擾łȂ̂ňӖȂIiXPɂāj
		if(pCurrent != NULL)
		{	// ݂̕\ݒ󂯌pB
			pCurrent->GetCurrentInfo(fs);
		}
		else
		{	// ݒ́uڍו\v
			fs->ViewMode = FVM_DETAILS;
			fs->fFlags   = FWF_AUTOARRANGE | FWF_CHECKSELECT;
		}
	}

	// Oŏꍇtrue, ftHg̏ꍇfalse.
	// ̎̏́A
	// tH_܂̓tH_ւ̃V[gJbgPIĂꍇ̂݁A
	// OnDefaultDirectoryChange()Ăяo܂B
	// ȊÓAftHg̏ɔC܂B
	bool OnDefaultCommand(const CShellItemList* pItems)
	{
		UINT cFiles = pItems->GetCount();
		CComPtr<IShellFolder> pCurrentParent = m_pCurrentFolder;
		T* pThis = static_cast<T*>(this);

		for(UINT i = 0; i < cFiles; i++)
		{
			SHDESCRIPTIONID desc;
			const CShellItem* pLeaf = pItems->GetAt(i);
			CAutoPtr<CShellItemTask> pFullPath = CShellItemTask::Concat(pItems->GetParent(), pLeaf);
			CComPtr<IShellFolder> pSelfFolder;
			if FAILED(pFullPath->GetDescription(&desc))
			{	//  SHDESCRIPTIONID ̎擾ɎsÂ܂܃ftHgsɔCB
				// Rg[pl̃ACeȂǂŔB
				pThis->OnDefaultExcecute(pFullPath);
				continue;
			}
			if(desc.dwDescriptionId == SHDID_ROOT_REGITEM)
			{	// tH_i}ChLgA}CRs[^ARpl̃ACeȂǁj
				if FAILED(pFullPath->GetSelfFolder(&pSelfFolder))
				{	// tH_ۂ`FbNAtH_łȂ΃ftHgsB
					pThis->OnDefaultExcecute(pFullPath);
					continue;
				}
				// ɗcc
			}
			else if(desc.dwDescriptionId == SHDID_FS_FILE)
			{	// t@C܂̓fXNgbvACȅꍇ́AV[gJbgǂׂB
				CShellLink link;
				CAutoPtr<CShellItemTask> pResolved;
				CComPtr<IShellFolder> pParentFolder;
				if(FAILED(link.SetSource(pFullPath))
				|| FAILED(link.GetDestination((ITEMIDLIST**)&pResolved.m_p))
				|| FAILED(pResolved->GetDescription(&desc))
				|| desc.dwDescriptionId == SHDID_FS_FILE)
				{
					pThis->OnDefaultExcecute(pFullPath);
					continue;
				}
				// tH_ւ̃V[gJbgB
				pFullPath = pResolved;
				if FAILED(pFullPath->GetSelfFolder(&pSelfFolder))
					continue;
			}
			else
			{
				pLeaf->GetSelfFolderRelative(&pSelfFolder, pCurrentParent);
			}
			if(!pSelfFolder)
				continue;
			if(pCurrentParent != m_pCurrentFolder)
			{	// ̃tH_ɑ΂Ĉړ悤ƂĂB
				// łɈړς݂Ȃ̂ŁALZB
				continue;
			}
			pThis->OnDefaultDirectoryChange(pFullPath, pSelfFolder);
		}
		return true;
	}

	// ftHgR}hŃfBNgړꍇɌĂ΂܂B
	void OnDefaultDirectoryChange(const CShellItem* pFullPath, IShellFolder* pShellFolder)
	{
		GoAbsolute(pFullPath, pShellFolder);
	}

	// 
	void OnDefaultExcecute(const CShellItem* pFullPath)
	{
		pFullPath->ShellExecute(m_hWnd);
	}

	// fBNgړ钼OɌĂ΂܂B
	// false ԂƈړLZ܂B
	bool OnDirectoryChanging(const CShellItem* pFullPath)
	{
		return true;
	}

	// fBNgړɌĂ΂܂B
	void OnDirectoryChanged(const CFileListCtrlTravelEntry* entry, IShellFolder* pShellFolder)
	{
	}

public:
	BOOL PreTranslateMessage(LPMSG pMsg)
	{
		// obNXy[XTranslateAccelerator()ɋȂ߂̓ʏB
		// At@Cl[͂̂܂܏ė~߁AeŔʂĂB
		// l[̃GfBbg{bNX̐e m_ViewWindow ł͂ȂA̎q̃Xgr[̂߁B
		if(::GetParent(pMsg->hwnd) == m_ViewWindow && pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_BACK)
		{
			return FALSE;
		}
		if(m_pShellView)
			return m_pShellView->TranslateAccelerator(pMsg) == S_OK;
		else
			return FALSE;
	}

	BEGIN_MSG_MAP(CFileListCtrlImpl)
		MESSAGE_HANDLER(WM_DESTROY			, OnDestroy)
		MESSAGE_HANDLER(WM_SIZE				, OnSize)
		MESSAGE_HANDLER(WM_SETFOCUS			, OnSetFocus)
		MESSAGE_HANDLER(WM_ERASEBKGND		, OnEraseBkgnd)
		MESSAGE_HANDLER(WM_GETISHELLBROWSER	, OnGetIShellBrowser)
		MESSAGE_HANDLER(WM_CONTEXTMENU		, OnContextMenu)
	END_MSG_MAP()

//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)

	LRESULT OnContextMenu(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{	// xftHg̃ReLXgj[ɖ߂
		m_ViewWindow.DefaultContextMenu(wParam, lParam);
		return 0;
	}

	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
	{
		if(m_ViewWindow)
		{
			m_ViewWindow.UnsubclassWindow();
		}
		if(m_pShellView)
		{
			m_pShellView->UIActivate(SVUIA_DEACTIVATE);
			m_pShellView->DestroyViewWindow();
			m_pShellView.Release();
		}
		bHandled = FALSE;
		return 0;
	}

	LRESULT OnSize(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		T* pThis = static_cast<T*>(this);
		pThis->UpdateLayout();
		return 0;
	}

	LRESULT OnSetFocus(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		if(m_ViewWindow.IsWindow())
			m_ViewWindow.SetFocus();
		return 0;
	}

	LRESULT OnEraseBkgnd(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		// wihKv͖
		return 1;
	}

	LRESULT OnGetIShellBrowser(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
	{
		//AddRef() ͕KvȂB
		//SetWindowLong(DWL_MSGRESULT, (LONG)(IShellBrowser*)this); //use this if dialog
		return (LRESULT)(IShellBrowser*)this;
	}

	//IShellBrowser
    STDMETHOD(InsertMenusSB) (HMENU hmenuShared, LPOLEMENUGROUPWIDTHS lpMenuWidths)
	{
//		ATLTRACE(__FUNCTION__ "\n");
		return E_NOTIMPL;
	}
    STDMETHOD(SetMenuSB) (HMENU hmenuShared, HOLEMENU holemenuReserved,HWND hwndActiveObject)
	{
//		ATLTRACE(__FUNCTION__ "\n");
		return E_NOTIMPL;
	}
    STDMETHOD(RemoveMenusSB) (HMENU hmenuShared)
	{
//		ATLTRACE(__FUNCTION__ "\n");
		return E_NOTIMPL;
	}
	STDMETHOD(OnViewWindowActive)(struct IShellView *ppshv)
	{
//		ATLTRACE(__FUNCTION__ "\n");
		return E_NOTIMPL;
	}

	STDMETHODIMP BrowseObject(LPCITEMIDLIST pidl, UINT wFlags)
	{
		const DWORD SBSP_BROWSER_MASK	= 0x00000003;
		const DWORD SBSP_MODE_MASK		= 0x000000F0;
		const DWORD SBSP_NAVIGATE_MASK	= 0x0000F000;

		bool autoSelect = (wFlags & SBSP_NOAUTOSELECT) == 0;

		switch(wFlags & SBSP_BROWSER_MASK)
		{
		case SBSP_DEFBROWSER:
		case SBSP_SAMEBROWSER:
			break;
		case SBSP_NEWBROWSER:
		default:
			ATLTRACE(_T("E_NOTIMPL : BrowseObject(SBSP_NEWBROWSER)\n"));
			return E_FAIL;
		}

		switch(wFlags & SBSP_BROWSER_MASK)
		{
		case SBSP_DEFMODE:
			break;
		case SBSP_EXPLOREMODE:
		default:
			ATLTRACE(_T("E_NOTIMPL : BrowseObject(SBSP_EXPLOREMODE)\n"));
			return E_FAIL;
		}

		switch(wFlags & SBSP_NAVIGATE_MASK)
		{
		case SBSP_ABSOLUTE:
			return GoAbsolute((const CShellItem*)pidl);
		case SBSP_RELATIVE:
			return GoRelative((const CShellItem*)pidl);
		case SBSP_PARENT:
			return GoUp(1, autoSelect);
		case SBSP_NAVIGATEBACK:
			return GoBack(1, autoSelect);
		case SBSP_NAVIGATEFORWARD:
			return GoForward(1, autoSelect);
		default:
			ATLTRACE(_T("E_NOTIMPL : BrowseObject(0x%08X)\n"), wFlags);
			return E_FAIL;
		}
	}
	STDMETHODIMP QueryActiveShellView(IShellView ** ppshv)
	{
		ATLASSERT(ppshv);
		return m_pShellView.CopyTo(ppshv);
	}
    STDMETHODIMP OnDefaultCommand(IShellView* pShellView)
	{
		ATLASSERT(m_pShellView.IsEqualObject(pShellView));
		// OŏꍇS_OK, ftHg̏ꍇS_FALSE.
		CAutoPtr<CShellItemListGlobal> items = GetSelectedItems();
		if(!items)
			return S_FALSE;
		T* pThis = static_cast<T*>(this);
		return pThis->OnDefaultCommand(items) ? S_OK : S_FALSE;
	}
	STDMETHODIMP GetViewFlags(DWORD *pdwFlags)
	{	// ׂẴt@C\ׂۂ̖₢킹B
		// CDB2GVF_SHOWALLFILES: Bt@C\B
		// 0: Bt@C\ȂB
		//*pdwFlags = CDB2GVF_SHOWALLFILES;
		return S_OK;
	}

public: // Iy[V
	CAutoPtr<CShellItemListGlobal> GetSelectedItems(bool vieworder = false)
	{
		return GetShellItems(SVGIO_SELECTION | (vieworder ? SVGIO_FLAG_VIEWORDER : 0));
	}
	CAutoPtr<CShellItemListGlobal> GetAllItems(bool vieworder = true)
	{
		return GetShellItems(SVGIO_ALLVIEW | (vieworder ? SVGIO_FLAG_VIEWORDER : 0));
	}
	CAutoPtr<CShellItemListGlobal> GetShellItems(DWORD svgio)
	{
		ATLASSERT((svgio & SVGIO_TYPE_MASK) == SVGIO_SELECTION || (svgio & SVGIO_TYPE_MASK) == SVGIO_ALLVIEW);
		// SVGIO_BACKGROUND     :
		// SVGIO_SELECTION      :
		// SVGIO_ALLVIEW        :
		// SVGIO_CHECKED        : XPł́ACHECED ͎ĂȂ炵B
		// SVGIO_FLAG_VIEWORDER :
		CAutoPtr<CShellItemListGlobal> ret;
		if(!m_pShellView)
			return ret;
		CComPtr<IDataObject> pDataObject;
		if FAILED(m_pShellView->GetItemObject(svgio, IID_IDataObject, (void**)&pDataObject))
			return ret;
		static CFormatEtc FORMAT_IDLIST (CFSTR_SHELLIDLIST, TYMED_HGLOBAL);
		STGMEDIUM medium;
		if FAILED(pDataObject->GetData(&FORMAT_IDLIST, &medium))
			return ret;
		ret.Attach((CShellItemListGlobal*)::GlobalLock(medium.hGlobal));
		return ret;
	}

	HRESULT SelectItems(const CShellItemList* items, UINT svsi = SVSI_SELECT)
	{
		if(!m_pShellView || !items)
			return E_FAIL;
		UINT nCount = items->GetCount();
		for(UINT i = 0; i < nCount; i++)
		{
			m_pShellView->SelectItem(items->GetAt(i), svsi);
		}
		return S_OK;
	}

	HRESULT DeselectAll()
	{
		if(!m_pShellView)
			return E_FAIL;
		return m_pShellView->SelectItem(NULL, SVSI_DESELECTOTHERS);
	}

	HRESULT GetFolderSettings(FOLDERSETTINGS* fs)
	{
		if(!m_pShellView)
			return E_FAIL;
		return m_pShellView->GetCurrentInfo(fs);
	}

	HRESULT SetFolderSettings(FOLDERSETTINGS* fs)
	{
		if(!m_pCurrentFolder)
			return E_FAIL;
		return ReCreateViewWindow(m_pCurrentFolder, fs);
	}

	template < class Inserter >
	HRESULT QueryTravelLog(Inserter& ins, INT num) const
	{
		if(num < 0)
		{
			for(INT i = -1; i >= num; i--)
			{
				INT index = (INT)m_CurrentIndex + i;
				if(index < 0)
					break;
				ins((const CFileListCtrlTravelEntry*)m_TravelLog[index]);
			}
		}
		else
		{
			for(INT i = 1; i <= num; i++)
			{
				INT index = (INT)m_CurrentIndex + i;
				if(index >= (INT)m_TravelLog.GetCount())
					break;
				ins((const CFileListCtrlTravelEntry*)m_TravelLog[index]);
			}
		}
		return S_OK;
	}

	HRESULT Refresh()
	{
		return m_pShellView ? m_pShellView->Refresh() : E_FAIL;
	}

	HRESULT GoAbsolute(const CShellItem* pFullPath, IShellFolder* pShellFolderHint = NULL)
	{
		return ChangeDirectory(pFullPath, pShellFolderHint, true);
	}

	HRESULT GoRelative(const CShellItem* pRelative, IShellFolder* pShellFolderHint = NULL)
	{
		ATLTRACE(_T("E_NOTIMPL : GoRelative()\n"));
		return E_NOTIMPL;
	}

	HRESULT GoUp(INT num = 1, bool autoSelect = true)
	{
		// GoAbsolute() Lłė~߁A[JϐɃRs[쐬B
		CAutoPtr<CShellItemTask> item = CShellItemTask::Duplicate(GetCurrentFolderItem());
		while(--num > 0 && SUCCEEDED(item->RemoveLeaf())) {}
		CComPtr<IShellFolder> pParentFolder;
		CShellItem* pLeaf;
		HRESULT hr = item->GetParentFolder(&pParentFolder, &pLeaf);
		if(FAILED(hr) || pLeaf->mkid.cb == 0)
			return hr;
		// [m[h菜ĂB"Parent/Leaf" => "Parent\0Leaf" ƂC[WB
		WORD sz = pLeaf->mkid.cb;
		pLeaf->mkid.cb = 0; // item->RemoveLeaf(pLeaf)
		//
		hr = GoAbsolute(item, pParentFolder);
		if FAILED(hr)
			return hr;
		if(autoSelect)
		{	// ȑÕtH_ɃJ[\ړB
			// pLeafĂїLɂ
			pLeaf->mkid.cb = sz;
			// MSDN ł "uFlags: This parameter can be one of the following values" ɂȂĂ邪A
			// ۂɂ̓rbgtÔߕw肪\B
 			m_pShellView->SelectItem(pLeaf, SVSI_FOCUSED | SVSI_SELECT | SVSI_ENSUREVISIBLE);
		}
		return S_OK;
	}

	HRESULT GoBack(INT num = 1, bool autoSelect = true)
	{
		size_t newIndex = (size_t)max((INT)m_CurrentIndex - num, 0);
		if(newIndex == m_CurrentIndex)
			return E_FAIL;
		m_CurrentIndex = newIndex;
		return ChangeDirectory(GetCurrentFolderItem());
	}

	HRESULT GoForward(INT num = 1, bool autoSelect = true)
	{
		size_t newIndex = min(m_CurrentIndex + num, m_TravelLog.GetCount()-1);
		if(newIndex == m_CurrentIndex)
			return E_FAIL;
		m_CurrentIndex = newIndex;
		return ChangeDirectory(GetCurrentFolderItem());
	}

	HRESULT GoHome()
	{
		CAutoPtr<CShellItemTask> pItem = CShellItemTask::FromCSIDL(CSIDL_PERSONAL, m_hWnd);
		if(!pItem)
			return E_FAIL;
		return GoAbsolute(pItem);
	}

private:
	HRESULT ChangeDirectory(const CShellItem* pFullPath, IShellFolder* pShellFolderHint = NULL, bool newTravel = false)
	{
		T* pThis = static_cast<T*>(this);

		if(!pThis->OnDirectoryChanging(pFullPath))
		{
			return E_ABORT;
		}

		HRESULT hr;
		CComPtr<IShellFolder> pShellFolder(pShellFolderHint);
		if(!pShellFolder && FAILED(hr = pFullPath->GetSelfFolder(&pShellFolder)))
		{
			ATLTRACE("ERROR: CFileListCtrlImpl.ChangeDirectory(), GetSelfFolder()\n");
			if FAILED(hr = SHGetDesktopFolder(&pShellFolder))
				return hr;
		}

		if FAILED(ReCreateViewWindow(pShellFolder))
			return hr;

		//
		if(newTravel)
		{
			// qXgɒǉ
			if(m_CurrentIndex > MAX_TRAVEL_LOG)
				m_CurrentIndex = MAX_TRAVEL_LOG-1;
			if(m_TravelLog.GetCount() > m_CurrentIndex+1)
				m_TravelLog.SetCount(m_CurrentIndex+1); // m_CurrentIndexȍ~̓JbgB
			CAutoPtr<CFileListCtrlTravelEntry> entry(new CFileListCtrlTravelEntry(pFullPath));
			m_TravelLog.Add(entry);
			m_CurrentIndex = m_TravelLog.GetCount()-1;
		}
		ATLASSERT(m_CurrentIndex < m_TravelLog.GetCount());
		pThis->OnDirectoryChanged(m_TravelLog[m_CurrentIndex], pShellFolder);
		return S_OK;
	}

	HRESULT ReCreateViewWindow(IShellFolder* pShellFolder, FOLDERSETTINGS* fs = NULL)
	{
		HRESULT hr;
		T* pT = static_cast<T*>(this);

		ATLASSERT(pShellFolder);
		CComPtr<IShellView> pNewShellView;
		hr = pShellFolder->CreateViewObject(m_hWnd, IID_IShellView, (void**)&pNewShellView);
		if FAILED(hr)
		{
			ATLTRACE("ERROR: CFileListCtrlImpl.ReCreateViewWindow(), CreateViewObject()\n");
			return hr;
		}

		FOLDERSETTINGS fsbuf = { 0 };
		if(!fs)
		{
			pT->UpdateFolderSettings(m_pShellView, pNewShellView, &fsbuf);
			fs = &fsbuf;
		}

		if(m_ViewWindow)
		{
			m_ViewWindow.UnsubclassWindow();
		}

		HWND hViewWindow = NULL;
		this->AddRef();
		hr = pNewShellView->CreateViewWindow(m_pShellView, fs, this, &rcDefault, &hViewWindow);
		if FAILED(hr)
		{
			ATLTRACE("ERROR: CFileListCtrlImpl.ReCreateViewWindow(), CreateViewWindow()\n");
			return hr;
		}

		// 쐬ɐB
		HWND hFocus = ::GetFocus();
		BOOL hasFocus = m_hWnd == hFocus || IsChild(hFocus);
		m_pCurrentFolder = pShellFolder;
		if(m_pShellView)
		{
			m_pShellView->UIActivate(SVUIA_DEACTIVATE);
			m_pShellView->DestroyViewWindow();
			m_pShellView.Release();
		}
		m_pShellView = pNewShellView;
		m_ViewWindow.SubclassWindow(hViewWindow);
		// ʏ́AԖڂ̎qXgr[Ȃ̂AtHgtH_̕\͈قȂ
		m_ListCtrl.Detach();
		for(CWindow wnd = m_ViewWindow.GetWindow(GW_CHILD); wnd; wnd = wnd.GetWindow(GW_HWNDNEXT))
		{
			TCHAR className[MAX_PATH];
			::GetClassName(wnd, className, MAX_PATH);
			if(lstrcmp(className, _T("SysListView32")) == 0)
			{
				m_ListCtrl.Attach(wnd);
				break;
			}
		}
		pT->UpdateLayout();
		m_pShellView->UIActivate(hasFocus ? SVUIA_ACTIVATE_FOCUS : SVUIA_ACTIVATE_NOFOCUS);
		return S_OK;
	}
};

////////////////////////////////////////////////////////////////////////

class CFileListCtrl : public CFileListCtrlImpl<CFileListCtrl>
{
public:
	DECLARE_WND_SUPERCLASS(_T("FileListCtrl"), GetWndClassName())
};

////////////////////////////////////////////////////////////////////////

} // namespace mew
