// MenuProvider.h
#pragma once

namespace mew {

/////////////////////////////////////////////////////////////////////////////
// Classes in this file
//
// CMenuProvider<T>	: |bvAbvj[̃I[i[h[ꊇĈ@\񋟂B

/////////////////////////////////////////////////////////////////////////////
// CMenuProvider<T>
// j[voC_́A{ȊOeɂȂĂ
// |bvAbvj[ɑ΂郁bZ[W󂯎̂ŁA
// CHAIN_MSG_MAP(CMenuProvider<T>) bZ[WnhȂꍇɂ̂݁A
// j[bZ[WׂłBibZ[W}bvŐCHAINĂ΂悢j

template < class T >
class ATL_NO_VTABLE CMenuProvider
{
private:
	CWindow			m_WndTrackPopupMenu;

public: // Overrrides
	UINT DoTrackPopupMenu(HMENU hMenu, POINT pt, HWND hWnd, UINT uFlags, LPTPMPARAMS lpParams)
	{
		return ::TrackPopupMenuEx(hMenu, uFlags, pt.x, pt.y, hWnd, lpParams);
	}

public: // Operations
	UINT TrackPopupMenu(HMENU hMenu, POINT pt, HWND hWnd, UINT uFlags, LPTPMPARAMS lpParams)
	{
		ATLASSERT(m_WndTrackPopupMenu == NULL && "TPM_RECURSE ɂ͑ΉĂ܂");
		T* pT = static_cast<T*>(this);
		bool bReturnCommand = ((uFlags & TPM_RETURNCMD) != 0);
		m_WndTrackPopupMenu.Attach(hWnd);
		UINT cmd = pT->DoTrackPopupMenu(hMenu, pt, hWnd, uFlags, lpParams);
		m_WndTrackPopupMenu.Detach();
		if(!bReturnCommand)
			::PostMessage(hWnd, WM_COMMAND, cmd, 0);
		return cmd;
	}

public: // Message Map
	BEGIN_MSG_MAP(CMenuProvider)
		MESSAGE_HANDLER(WM_DRAWITEM			, OnDrawItem)
		MESSAGE_HANDLER(WM_MEASUREITEM		, OnMeasureItem)
		MESSAGE_HANDLER(WM_INITMENUPOPUP	, OnMenuMessage)
		MESSAGE_HANDLER(WM_MENUCHAR			, OnMenuMessage)
		MESSAGE_HANDLER(WM_MENUSELECT		, OnMenuMessage)
	END_MSG_MAP()

	LRESULT OnDrawItem(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		T* pT = static_cast<T*>(this);
		DRAWITEMSTRUCT* pParam = (DRAWITEMSTRUCT*)lParam;
		if(pParam->CtlType != ODT_MENU || !m_WndTrackPopupMenu || m_WndTrackPopupMenu == pT->m_hWnd)
		{
			bHandled = FALSE;
			return 0;
		}
		else
		{
			return m_WndTrackPopupMenu.SendMessage(uMsg, wParam, lParam);
		}
	}

	LRESULT OnMeasureItem(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		T* pT = static_cast<T*>(this);
		MEASUREITEMSTRUCT* pParam = (MEASUREITEMSTRUCT*)lParam;
		if(pParam->CtlType != ODT_MENU || !m_WndTrackPopupMenu || m_WndTrackPopupMenu == pT->m_hWnd)
		{
			bHandled = FALSE;
			return 0;
		}
		else
		{
			return m_WndTrackPopupMenu.SendMessage(uMsg, wParam, lParam);
		}
	}

	LRESULT OnMenuMessage(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		T* pT = static_cast<T*>(this);
		if(!m_WndTrackPopupMenu || m_WndTrackPopupMenu == pT->m_hWnd)
		{	// g̃j[bZ[ẂACUpdateUI ɔCB
			bHandled = FALSE;
			return 0;
		}
		else
		{	// ̃EBhEw肳Ăꍇ́AɑMB
			return m_WndTrackPopupMenu.SendMessage(uMsg, wParam, lParam);
		}
	}
};

/////////////////////////////////////////////////////////////////////////////

} // namespace mew
