// PathUtil.h
#pragma once

#include <atlutil.h>

namespace mew {

// { atlisapi.h Œ`Ă֐łA
// ]vȃwb_CN[h _ATL_MIN_CRT Ƃ̑̂ŁAꂾ܂B

//  szBuf ́A܂ UTF-8 łBShiftJIS nȂ悤ɁI
ATL_NOINLINE inline bool EscapeUTF8ToCString(CStringA& string, LPCSTR szBuf) throw()
{
	ATLASSERT( szBuf != NULL );

	_ATLTRY
	{
		CHAR szEscaped[512];
		LPSTR pszStr = szEscaped;
		DWORD dwLen = 0;

		while (*szBuf)
		{
			if (dwLen+4 >= 512)
			{
				*pszStr = '\0';
				string.Append(szEscaped, dwLen);
				pszStr = szEscaped;
				dwLen = 0;
			}
			if (AtlIsUnsafeUrlChar(*szBuf))
			{
				if (*szBuf == ' ')
				{
					dwLen++;
					*pszStr++ = '+';
				}
				else
				{
					LPSTR pszTmp = pszStr;
					*pszTmp++ = '%';
					unsigned char ch = (unsigned char)*szBuf;
					if (ch < 16)
					{
						*pszTmp++ = '0';
					}
					_ultoa((unsigned char)ch, pszTmp, 16);
					pszStr+= sizeof("%FF")-1;
					dwLen+= sizeof("%FF")-1;
				}
			}
			else
			{
				*pszStr++ = *szBuf;
				dwLen++;
			}
			szBuf++;
		}

		*pszStr = '\0';
		string.Append(szEscaped, dwLen);
	}
	_ATLCATCHALL()
	{
		return false;
	}

	return true;
}

ATL_NOINLINE inline bool EscapeToCString(CStringA& string, LPCWSTR wszBuf) throw()
{
	_ATLTRY
	{
		// convert string to UTF8
		CFixedStringT<CStringA, 2048> strConvert;

		// get the required length for conversion
		int nSrcLen = (int) wcslen(wszBuf);
		int nLen = AtlUnicodeToUTF8(wszBuf, nSrcLen, NULL, 0);
		if (!nLen)
		{
			return false;
		}

		// allocate MBCS conversion string
		LPSTR sz = strConvert.GetBuffer(nLen+1);
		if (!sz)
		{
			return false;
		}

		// do the UNICODE to UTF8 conversion
		nLen = AtlUnicodeToUTF8(wszBuf, nSrcLen, sz, nLen);
		if (!nLen)
		{
			return false;
		}

		// null-terminate
		sz[nLen] = '\0';

		// delegate to ANSI version of EscapeToCString
		if (!EscapeUTF8ToCString(string, sz))
		{
			return false;
		}

		strConvert.ReleaseBuffer(nLen);
	}
	_ATLCATCHALL()
	{
		return false;
	}

	return true;
}

////////////////////////////////////////////////////////////////////////////////
// Lightweight path/url utilities

inline bool UrlAddSlash(LPTSTR url)
{
	int len = lstrlen(url);
	if(len == 0 || url[len-1] != _T('/'))
	{
		url[len  ] = _T('/');
		url[len+1] = _T('\0');
	}
	return true;
}

inline bool UrlRemoveLeaf(LPTSTR url)
{
	LPTSTR start = StrStr(url, _T("://"));
	if(start == NULL)
		return false;
	int len = lstrlen(url);
	if(len < 4)
		return false;
	LPTSTR end = url + len;
	if(*(end-1) == _T('/'))
		*--end = _T('\0');
	LPTSTR prevsep = StrRChr(start+3, end, _T('/'));
	if(prevsep == NULL)
		return false;
	*prevsep = _T('\0');
	return true;
}

// URL /index.htm* ŏIĂ邩ǂ𔻒肷B
inline bool UrlIsIndex(LPCTSTR url)
{
	LPCTSTR leaf = StrRChr(url, NULL, _T('/'));
	return leaf && StrCmpNI(leaf+1, _T("index.htm"), 9) == 0; // 9 == strlen("index.htm")
}

// pX \index.htm* ŏIĂ邩ǂ𔻒肷B
inline bool PathIsIndex(LPCTSTR path)
{
	return StrCmpNI(PathFindFileName(path), _T("index.htm"), 9) == 0; // 9 == strlen("index.htm")
}

// URL̃R܂ł̕ԂB
inline int UrlFindScheme(LPCTSTR url)
{
	LPCTSTR colon = StrChr(url, _T(':'));
	if(colon)
		return (int)(colon - url);
	else
		return -1;
}

// {́AIUniformResourceLocator g炵B
inline bool ResolveInternetShortcut(LPTSTR dst, LPCTSTR src)
{
	if(lstrcmpi(PathFindExtension(src), _T(".url")) == 0)
	{	// IEC^[lbgV[gJbgigq .urljp̓ʏB
		// .url ́Ag͒PȂ init@Ĉ悤B
		if(GetPrivateProfileString(_T("InternetShortcut"), _T("URL"), NULL, dst, MAX_PATH, src) > 0)
			return true;
	}
	// V[gJbgł͂Ȃꍇ
	if(dst != src)
		lstrcpy(dst, src);
	return false;
}

////////////////////////////////////////////////////////////////////////////////

} // namespace mew
